/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
 
 /* UTILITY FUNCTIONS */


var clickevent=new CustomEvent("didclick", 
	{
		bubbles: true,
		cancelable: true
	}
);


var dashlog=function(str) {
	var d=document.getElementById('minidash');
	if(d) d.innerHTML=str;
};

var changeclass=function(element,classname,remove) {
	if(!element) return;
	if(remove===true) {
		element.classList.remove(classname);
	} else {
		element.classList.add(classname);
	}
};

var taketaps=function(element,taptype,func) {
// avoid adding the same listener multiple times

	if(!element) {
	//console.log("*********** trying to add to nonexistent element"); 
	return;}

	cleartaps(element,taptype,func);
	cleartaps(element,taptype,buttonclick);

	if(taptype=='click') {
	
	setTimeout(function() {

	element.addEventListener(app.tap.down,clickdown);
	element.addEventListener(app.tap.move,clickmove);
	element.addEventListener(app.tap.up,clickup);
	element.addEventListener("didclick",func);

//	element.addEventListener(app.tap[taptype],func);
	
	//element.addEventListener(app.tap[taptype],buttonclick);
	},1);
	} else {


// delay a few ms before adding listener, to avoid picking up any currently active presses as the DOM redraws

	setTimeout(function() {

		element.addEventListener(app.tap[taptype],func);
	
	element.addEventListener(app.tap.up,clickup);
	//element.addEventListener(app.tap[taptype],buttonclick);
	},1);
	}

};

var cleartaps=function(element,taptype,func) {
	if(!element) {
	//console.log("*********** trying to clear nonexistent element"); 
	return;}
	if(taptype=='click') {
		element.removeEventListener(app.tap.down,clickdown);
		element.removeEventListener(app.tap.up,clickup);
		element.removeEventListener(app.tap.move,clickmove);
		element.removeEventListener("didclick",func);
	} else {
		element.removeEventListener(app.tap[taptype],buttonclick);
		element.removeEventListener(app.tap[taptype],func);
	}
};

var buttonclick=function() {
	soundtrack.play('click');
};

var lookup=function(id) {
	return app.globals[id];
};

var zeropad=function(num,digits) {
	var numstring=num.toString();
	if(!digits) digits=2;
	count=numstring.length;
	
	if(count>=digits) return numstring;
	
	for(var i=count;i<digits;i++) {
		numstring="0"+numstring;
	}
	
	return numstring;
};

var timestamp=function() {
	// return the current time in a particular format for saving. Maybe just leave as UTC, actually
	return Date.now();
};

var s=function(num,o) {	
	if(!o) {
		o=['s',''];
	}
	
	if(num===1) return o[1];	
	return o[0];
};




var savestate=function() {
	// do this when we're about to get kicked out of memory
	
};

var resumestate=function() {
	
};

var datenames={
	months:['January','February',"March",'April', 'May','June','July','August','September','October','November','December'],
	days:['Sunday','Monday','Tuesday', 'Wednesday','Thursday','Friday','Saturday']
};

var nicedate=function(date) {
	// return a nice date from a timestamp

	var date=new Date(date);

	var nice=(date.getMonth()+1) + "/" + date.getDate() + "/" + date.getFullYear() + " " + date.getHours() + ":" + zeropad(date.getMinutes()) + ":" + zeropad(date.getSeconds());
	return nice;
};

var logdate=function(date,level) { // level can be 'year','month','day','hour','minute','sec'
	var date=new Date(date);
	var nice=date.getFullYear();
	if(level!='year') {
		nice+=zeropad(1+parseInt(date.getMonth()));
		if(level!='month') {
			nice+=zeropad(date.getDate());
			if(level!='day') {
				nice+="_"+zeropad(date.getHours());
				if(level!='hour') {
					nice+="."+zeropad(date.getMinutes());
					if(level!='minute') {
						nice+="."+zeropad(date.getSeconds());
					}
				}
			}
		}
	}
	
	return nice;
//	return (date.getFullYear());
};



var io={
		datadir:null,
		ready:false,
		writing:false,
		savestuff:[],
		filewriters:{},
		filereaders:{},
		getdata:function(filename) {
			user.setdata({});
			
			//return;
			filename=filename+".txt";
			var me=this;
			
			window.resolveLocalFileSystemURL(this.datadir,
				function(dirEntry) {		
					dirEntry.getFile(filename, {create: true, exclusive: false}, function(fileEntry) {
       				//window.alert("read " + fileEntry);
						io.readFile(fileEntry);
					},function(error) {
						for(var key in error) {
//							errors+=key + " " + value + "";
						}
						io.ready=true;
					//	window.alert(errors);
					});
			});
		},
		
		readFile:function(fileEntry) {
			fileEntry.file(function (file) {	
       			var reader = new FileReader();
       			reader.onloadend = function() {


//            		displayFileData(fileEntry.fullPath + ": " + this.result);
//					window.alert("read the file");
					user.setdata(JSON.parse(this.result));
					io.ready=true;
					logdata.appstate('launch');
					logdata.nav('launch');
					
//					user.dataready();
//					window.alert("read the file!");
        		};
       			reader.readAsText(file);
			});
		},
		
		savedata:function(data,filename) {
			//var me=this;
			this.savestuff.push([data,filename]);
			if(!this.writing) {
				this.checkformore();
			}
		},
		
		savethedata:function(data,filename) {
			io.writing=true;
			if(this.filewriters[filename]) {
				window.alert("already have a writer");
//				this.writeFile(this.filewriters[filename],data);
//				return;
			}
			
			window.resolveLocalFileSystemURL(this.datadir, function (dirEntry) {
    			io.createFile(dirEntry, filename+".txt",data);
			});
		},
		
		checkformore:function() {
			if(this.savestuff.length > 0) {
				var tosave=this.savestuff.pop();				
//				window.alert("save another");
				this.savethedata(tosave[0],tosave[1]);
			} else {
//				window.alert("finish saving");
 	       		this.writing=false;
			}
		},
		
		createFile:function(dirEntry,filename,data,append){
			dirEntry.getFile(filename, {create: true, exclusive: false}, function(fileEntry) {
				io.filewriters[filename]=fileEntry;
        		io.writeFile(fileEntry, data, append);
    		});
		},
		
		writeFile:function(fileEntry, data, append) {
			fileEntry.createWriter(function (fileWriter) {
 	       		fileWriter.onwriteend = function(evt){
 	       			io.checkformore();
                }
                fileWriter.onerror=function() {
//                	window.alert("writing error");
                }
 	       		
 	       if (append) {
        	    try {
        	        fileWriter.seek(fileWriter.length);
        	    }
        	    catch (e) {
//        	        console.log("file doesn't exist!");
        	    }
        	}
 	       		
 	       		fileWriter.write(data);
 	       		
 	       	//	console.log("writing something");
 	       	//	window.alert("writing something");

 	       });
		},
		
		appenddata:function(filename,data) {
			window.resolveLocalFileSystemURL(this.datadir, function (dirEntry) {
    			io.createFile(dirEntry, filename+".txt",data,true);
			});
		},

		
		keepimage:function(imageuri,filename) {
			// move the image from the temp folder into a new permanent place
			this.moveFile(imageuri,this.datadir,filename);
//			window.alert("keep image at " + this.datadir + "/" + filename);
			return filename;
		},
		
		moveFile:function(uri,newdir,filename){
			//window.alert("moveFile ");
			var me=this;
			window.resolveLocalFileSystemURL(uri, function(fileEntry) {
				//window.alert("got file at " + uri);
				window.resolveLocalFileSystemURL(newdir, function(dirEntry) {
     				 fileEntry.copyTo(dirEntry,filename,null,me.ioerror);
    			},me.ioerror);
			},me.ioerror);
		},
		
		removeimage:function(imageuri) {
			
		},
		
		ioerror:function(err) {
			// some kind of error
		},
		
		getURL:function(filename) {
			return(this.datadir + filename);
		},
		
		init:function() {
			this.datadir=cordova.file.dataDirectory;
		}
};

 
 
var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
        document.addEventListener('pause',this.pause, false);
        document.addEventListener('resume',this.resume,false);
        /* set up the touch/mouse mechanism */
        this.tap={};
    	this.tap.down='mousedown';
		this.tap.move='mousemove';
		this.tap.up='mouseup';
		if ('ontouchstart' in document.documentElement) {
			this.tap.down='touchstart';
			this.tap.move='touchmove';
			this.tap.up='touchend';
			this.istouch=true;
		}
//		this.tap.click2='click';
        this.tapcoords={x:0,y:0};
        this.lastcoords={x:0,y:0};
        
        
        /* get the screen size */
        this.getsize();
        
        this.missionproperty=this.missionproperty.bind(this);
    },
    
    
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        app.receivedEvent('deviceready');
        
        soundtrack.play('sting');
        app.ondevice=true;
        io.init();
		logdata.init();        
		geolocation.init();
        geolocation.getposition();

        user.pulldata(); // after device is ready, load the user data.

        //window.alert("ready");
        // set up the file writer
        //io.init();
        //init();
       // showcamera();
    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
       // window.alert("received event " + id);
    },
    pause:function() {
    	// save position? Maybe.
    	logdata.appstate('pause');
		logdata.nav('exit');
    },
    resume:function() {
    	// if on the home screen, update the dashboard
    	/* "interactive" functions (example used is 'alert') need to be called with a timeout on iOS:
    	
    	setTimeout(function() {
            // TODO: do your thing!
        }, 0);
    	*/
    	
    	if(document.getElementById('dashboard')) {
    		index.refresh();
    	}
    	// see when user was last here - load new day if it's a new day
    	
    	logdata.appstate('resume');
    	logdata.nav('resume');
    },
    // app methods
    // convert touch or mouse coordinates into 
    setcoords:function(ev) {
    ev.preventDefault(); // we're dragging or something, so prevent default
    this.lastcoords.x=this.tapcoords.x;
    this.lastcoords.y=this.tapcoords.y;
	this.tapcoords=getcoords(ev);
	return this.tapcoords;
	},
	getcoords:function(ev,pre) {
		if(pre) ev.preventDefault();
		if(this.istouch) {
//			window.alert("touch coords " + ev.touches.length);
			return {x:ev.touches[0].pageX,y:ev.touches[0].pageY};
		} else {
			return {x:ev.clientX,y:ev.clientY};
		}
	},
	
	// set main app frame size based on screen size
	getsize:function() {
		this.frame=document.getElementById('frame');
		this.width=app.frame.getBoundingClientRect().width;
		this.height=app.frame.getBoundingClientRect().height;
		this.pixelratio=100/this.width;
	},
	ondevice:false,
	
	currentid:function() {
		return this.mission;
	},
	
	missionproperty:function(prop,id) {
		if(!id) id=this.mission;
		return activitydata[id][prop];
	},

	
	globals:{},
	
	timers:{}

};

/*  USER DATA */

/*
each activity should have
- date last opened?
- status (started, finished, seen, skipped?)
- rating (after completed) - fave, positive, neutral, negative
- times completed
- (ever-growing) logs of when started and when completed.

- saved data
  - camera: pictures (URLs) (array)
  - scavenger hunt: results found (array of duples [id, found yes/no])
  - timer: time set (no saved; or possibly last time showing) (scalar)
  - stopwatch: resulting time (scalar)
  - counter: last count (scalar)
  - freeform - captured photo?

what about multi day activities?

User's overall status should have
 - list of unfinished activities
 - list of completed activities (with completion datestamp)
 - list of times using the app (maybe just update if its a new day)
 - score
 - 

*/

var logdata={
	navfile:"Nav_"+logdate(Date.now(),'month'),
	viewfile:"Views_"+logdate(Date.now(),'month'),
	launchfile:"Launch_"+logdate(Date.now(),'month'),
	closefile:"Completed_"+logdate(Date.now(),'month'),
	
	nav:function(nav) {
		this.appenddata(this.navfile,JSON.stringify(nav) + ",\n");
	},
	
	view:function(id) {
		this.appenddata(this.viewfile,JSON.stringify([id,Date.now()]) + ",\n");
	},

	appstate:function(state) {
	//	return;
		this.appenddata(this.launchfile,JSON.stringify([state,Date.now()])+",\n");
	},
	
	complete:function(data) {
		// data is a mission log - contains open,done,reset,points,*result*
		this.appenddata(this.closefile,JSON.stringify(data)+",\n");
	},
	
	appenddata:function(filename,str) {
		// just append the data to the log file
		if(app.ondevice) {
			io.appenddata(filename,str);
		}
	},
	
	
	init:function() {
		io.appenddata(this.navfile,"");
		io.appenddata(this.viewfile,"");
		io.appenddata(this.launchfile,"");
		io.appenddata(this.closefile,"");
	}
};

var user={
	activitysaved:{},
	tempdata:{}, // save to a temp file so that it's small and responsive while making changes, then pull the full history later? Maybe should log by...month?
	filename:"Userdata",
	tempfile:"temp",
	statclick:0, // click several times to show stats
	missionstatus:{
		completed:[],
		open:[],
		seen:[],
		fave:[]
	},
	score:{},
	status:{
		unseen:0,
		seen:1,
		open:2,
		done:3
	},
	rating:{
		fave:3,
		pos:2,
		mid:1,
		neg:0
	},
	
	dataready:function() {
//		window.alert("data ready");
//		this.updatemissionlists();
//		gohome(); // user data is ready at the beginning
	},
	
	// openmissions shows all missions the user has ever seen - some will be completed, others started but not completed, others never begun.

	showstatus:function(activityid) {
		var openmissions=this.loaddata('overall','openedmissions');
		if(!openmissions) return this.status.unseen;
		if(openmissions[activityid]) {
			return openmissions[activityid].status;
		}
		return this.status.unseen;
	},
	
	getminidash:function() {
		var md="";
		var c=user.missionstatus.completed.length;
		var p=user.loaddata('overall','points');
		if(c<1) return md;

//		var s=(c!==1)?'s':'';
//		md+=c + " mission" + s + "/";
		if(p) {
			md+=p + " points";
		}
		return md;
	},
	
	
	updatemissionlists:function() {
		// go through missions and send the counts of each
		this.missionstatus.seen=[];
		this.missionstatus.open=[];
		this.missionstatus.completed=[];
		for(var id in activitydata) {
			var status=this.showstatus(id);
			switch(status) {
				case this.status.seen:
				this.missionstatus.seen.push(id);
				break;
				
				case this.status.open:
				this.missionstatus.open.push(id);
				break;
				
				case this.status.done:
				this.missionstatus.completed.push(id);
				break;
			}
		}
	},
	
	setmissionopen:function(activityid,isopen,defer) {
		var val={open:Date.now(),done:null,points:0,resets:0};
		if(!isopen) val=null;
		this.savedata(activityid,'open',val,defer);
	},
	
	savetoopenmission:function(activityid,key,value,defer,index) {
		// open mission is the last one in the log file
		
/*
		var all=this.loaddata(activityid,'log');
		if(!all) {
			return null;
		}
		var ind=all.length-1;
		if(index && index < ind) {
			ind=index;
		}
		var om=all[ind];
		om[key]=value;
*/
		var om=this.loaddata(activityid,'open');
		if(om) {
			om[key]=value;
		}
		this.savedata(activityid,'open',om,defer);
	},
	
	loadfromopenmission:function(activityid,key,index) {
		var om=this.loaddata(activityid,'open');
		
/*
		var all=this.loaddata(activityid,'log');
		if(!all) {
			return null;
		}
		var ind=all.length-1;
		if(index && index < ind) {
			ind=index;
		}
		var om=all[ind];
*/
		if(!om) return null;
		if(key) {
			return om[key];
			}
//		 return null;
//		}
		return om;
	},

	seemission:function(activityid) {
		// this mission has been PRESENTED to the user as a daily activity
		var openmissions=this.loaddata('overall','openedmissions');
		if(openmissions==null) {
			openmissions={};
			openmissions[activityid]={'status':this.status.seen,'seen':1,'open':0,'done':0,'points':0};
			this.savedata('overall','openedmissions',openmissions,true);
		} else if(!openmissions[activityid]) {
			openmissions[activityid]={'status':this.status.seen,'seen':1,'open':0,'done':0,'points':0};
			this.savedata('overall','openedmissions',openmissions,true);
		} else {
			openmissions[activityid].seen++;
			this.savedata('overall','openedmissions',openmissions,true);
		}

// save that the user has seen it
		this.savedata(activityid,'status',this.status.seen,true);

// log this in viewed missions
		logdata.view(activityid);
/*		var missionlog=this.loaddata(activityid,'log');
		if(!missionlog) {
			missionlog={see:[],complete:[],begin:[],scored:0};
		}
		missionlog.see.push(timestamp());			
		this.savedata(activityid,'log',missionlog,true);
*/
		this.writedata();
	},

	openmission:function(activityid) {
		// user has opened a mission
		this.savedata(activityid,'status',this.status.open,true);
		
		var openmissions=this.loaddata('overall','openedmissions');
//		openmissions.push(activityid);

// put this mission in the list of open missions unless it's already there
		var newopen=true;
		if(openmissions==null) { // first time opening any mission
			openmissions={};
			openmissions[activityid]={'status':this.status.open,'seen':0,'open':1,'done':0,'points':0};
		} else if(!openmissions[activityid]) { // first time opening THIS mission
			openmissions[activityid]={'status':this.status.open,'seen':0,'open':1,'done':0,'points':0};
		} else if(openmissions[activityid].status != this.status.open) {
		// This mission has been opened before, but is not currently open
			openmissions[activityid].status=this.status.open;
			openmissions[activityid].open++;
		} else {
		// this mission is currently already open; don't timestamp a new opening
			newopen=false;
		}
		
		if(newopen) {
			this.savedata('overall','openedmissions',openmissions,true);
			this.setmissionopen(activityid,true,true);
			
			this.dailycredit('open',true);
			
/*
			var missionlog=this.loaddata(activityid,'log');
			var debugnew='';
			if(!missionlog) {
				missionlog=[];
				
//				debugnew=' NEW ';
			}
			
			
			
			missionlog.push({open:Date.now(),done:null,points:0,resets:0});
*/			
//			missionlog.begin.push(timestamp());
//			this.savedata(activityid,'log',missionlog,true);

			
			
//			window.alert("save log for " + activityid + " " + debugnew + missionlog.see.length + " " + missionlog.begin.length);
		}
		this.writedata();
	},
	
	completemission:function(activityid) {
	

		this.savedata(activityid,'status',this.status.done,true);

// stop the timer for this mission if it's running
		tools.timer.stoptimer(activityid);

		var missionlog=this.loaddata(activityid,'log');
//		if(!missionlog) window.alert("no mission log! " + activityid);
//		if(missionlog.complete.length < 1) score=150; // first time bonus
		
		
		var points=this.loaddata('overall','points');
		
		if(!points) points=0;
		
		var bonus=0;
		
		var openmissions=this.loaddata('overall','openedmissions');
		if(openmissions[activityid].done==0) bonus=50;
//		if() bonus=50;
		
		
//		if(missionlog.length <= 1) bonus=50;


		var score=100;
		cards.tallyup(points,score,bonus);
		score=score+bonus;
		
//		missionlog.scored+=score;
//		missionlog.complete.push(timestamp());
//		this.savedata(activityid,'log',missionlog,true);

		openmissions[activityid].status=this.status.done;
		openmissions[activityid].done++;
		openmissions[activityid].points+=score;
		this.savedata('overall','openedmissions',openmissions,true);

		var tm=this.loaddata('overall','totalmissions');
		if(!tm) tm=0;
		this.savetoopenmission(activityid,'points',score,true);
		this.savetoopenmission(activityid,'done',timestamp(),true);
		
		points+=score;
		this.savedata('overall','totalmissions',tm+1,true);

		this.savedata('overall','points',points);
		
// update the small dashboard		
//		var d=document.getElementById('minidash');
//		if(d) d.innerHTML=user.getminidash();
		
		var closedmission=this.loadfromopenmission(activityid);
		logdata.complete(closedmission);
		
		this.dailycredit('done',true);
		
		
		this.setmissionopen(activityid,false,true);
	},
	

	savedata:function(activityid,key,value,defer) {
		if(!this.activitysaved[activityid]) {
			this.activitysaved[activityid]={data:{}};
		}
		this.activitysaved[activityid].data[key]=value;
		if(!defer) {
			this.writedata();
		}

//		if(app.ondevice) {
//			this.savetodevice();
//		}
		
		this.updatemissionlists();

	},
	writedata:function() {
		if(app.ondevice) {
			this.savetodevice();
		}
	},
	
	loaddata:function(activityid,key) {
		if(!this.activitysaved[activityid]) {
			this.activitysaved[activityid]={data:{}}; // create new?
			//window.alert('no data for ' + activityid);
			return null;
		}
		if(key) {
			//window.alert('return data for ' + key + " in " + activityid + "=" +this.activitydata[activityid].data[key]);
			return this.activitysaved[activityid].data[key];
		}
		return this.activitysaved[activityid].data; // otherwise return everything
	},
	
	savetodevice:function() {
		var str=JSON.stringify(this.activitysaved);
		io.savedata(str,this.filename);
    },
	
	pulldata:function() {
		io.getdata(this.filename);
	},
	
	setdata:function(data) {
		this.activitysaved=data;
		this.updatemissionlists();
		index.refresh();
	},
	
	showalldata:function() {
		// show all user data
		this.statclick++;
		if(this.statclick < 8) return;
		var loglines=[];
		this.statclick=0;
		loglines.push("<table class=\"chart\" border=\"1\">");
		
		for(var id in this.activitysaved) {
			var activity=this.activitysaved[id];
			//	window.alert(id);
			if(id=='overall') {
			// overall saves opened missions (hash) and total points
				loglines.push("<tr><td colspan=\"4\">Total points: " + this.loaddata(id,'points') + "</td></tr>");
				//loglines.push("launches:");
				var launches=this.loaddata(id,'launch');
				for(var l in launches) {
					//loglines.push(launches[l][0] + ": " + nicedate(launches[l][1]));
					loglines.push("<tr><td>" + launches[l][0] + "</td><td colspan=\"4\">" + nicedate(launches[l][1]) + "</td></tr>");
				}
				//loglines.push("Open missions: " + this.loaddata(id,'openedmissions') );
			} else{
//			loglines.push('<span>'+id+'</span>');
			var tlog=this.loaddata(id,'log');
	//		loglines.push(log);
/*
			loglines.push('   times shown: ' + log.see.length );
			loglines.push('   times started: ' + log.begin.length );
			loglines.push('   times completed: ' + log.complete.length );
			loglines.push('   points earned: ' + log.scored );
*/

			var line=id + " : [ " + tlog.see.length + " ][ " + tlog.complete.length+"/" + tlog.begin.length + " ][ " + tlog.scored +" ]";
			line="<tr><td>" + id + " </td><td> " + tlog.see.length + " </td><td> " + tlog.complete.length+"/" + tlog.begin.length + " </td><td> " + tlog.scored +" </td>";
//			loglines.push('   rating: ' + this.loaddata(id,'rating') );
			//loglines.push('current status: ' + this.loaddata(id,'status') );
			var st=this.loaddata(id,'status');
			switch (st) {
				case this.status.done:			
				line+="<td>done</td>";
				break;
				
				case this.status.open:
				line+="<td>open</td>";
				break;
				
				default:
				line+="<td>" + st + "</td>";
				break;
			}
			line+="</tr>";
			
			loglines.push(line);
			}
			
		}
		
		loglines.push("</table>");


//		window.alert('stat');
		nav.go('stat',loglines);
//		panel.content.innerHTML=statdump;

	},
	
	cleardata:function() {

//		return;
		this.activitysaved={};
		if(app.ondevice) {	
			io.savedata(JSON.stringify(this.activitysaved),this.filename);
		}
		this.updatemissionlists();
	},
	
	whichdailies:function(length) {
		var lastdailyset=this.loaddata('overall','dailyset');

		var date=new Date(Date.now());
		var set={'last':0,'year':date.getFullYear(),'month':date.getMonth()+1,'day':date.getDate()};
	
		if(!lastdailyset) {
			this.savedata('overall','dailyset',set,true);
			return 0;
		} else {
			if(lastdailyset.year == set.year && lastdailyset.month == set.month && lastdailyset.day == set.day) { // same day as before
			
				return lastdailyset.last;
			} else {
				var nx=lastdailyset.last+1;
				if(nx >= length) nx=0;
				set.last=nx;
				this.savedata('overall','dailyset',set,true);
				return nx;
			}
		}
		
	},
	
	dailycredit:function(type,defer) {
		// give the user credit for doing something this day
		var md=this.loaddata('overall','missiondays');
		
		if(!md) {
			md={};
		}
		
		var t=Date.now();
		var dt=new Date(t);
		var tm=dt.getHours() + ":" + zeropad(dt.getMinutes());
		var d=logdate(t,'day');
		if(md[d]) {
			md[d].last=tm;
			if(type=='done') md[d].done++;
		} else {
			md[d]={'start':tm,'last':tm,'done':0};
		}
		
		this.savedata('overall','missiondays',md,defer);
	},
	
	init:function() {
		this.showalldata=this.showalldata.bind(this);
		this.cleardata=this.cleardata.bind(this);
	
/*	
		if(!this.activitydata) {
			this.pulldata();
		}*/
	}
};

user.init();



var panel={
	topnav:{dom:document.getElementById("topnav"),ui:{}},
	content:{dom:document.getElementById("content"),ui:{}},
	tool:{dom:document.getElementById("tool"),ui:{}},
	bottomnav:{dom:document.getElementById("bottomnav"),ui:{}},

	home:document.getElementById('homebtn'),
	
	
	setpanel:function(whichpanel,template,force) {
		var t=templates[template];

		if(whichpanel.active==template && !force) return; // this template has already been set, so don't set again (overriden by setting force to true)
		whichpanel.active=template;
		templates.subs=t.subs;

		whichpanel.dom.innerHTML=templates.parse(t.html);
		// set up buttons
		whichpanel.ui={}; // clear old UI out
		for(var bid in t.buttons) {
			var bconf=t.buttons[bid];
			whichpanel.ui[bid]=document.getElementById(bid);
			for(var b in bconf) {
				if(b=='tap') {
					//whichpanel.ui[bid].addEventListener(app.taptype,bconf[b]);
					taketaps(whichpanel.ui[bid],'click',bconf[b]);
				}
			}
		}
	},
	

	showpanel:function(whichpanel,doshow) {
		if(doshow===false) {
			changeclass(whichpanel.dom,'hidden');
		} else {
			changeclass(whichpanel.dom,'hidden',true);
		}
	},
	
	fullscreen:function() {
		this.showpanel(this.topnav,false);
		this.showpanel(this.bottomnav,false);
		tools.showtool(true);		
		this.showpanel(this.tool,false); // actually hide the tool first
		changeclass(this.content.dom,'list',true);
		changeclass(this.content.dom,'fullscreen');
	},
	
	shownav:function() {
		this.showpanel(this.topnav,true);
		this.showpanel(this.bottomnav,true);
		this.showpanel(this.tool,true);
		
		changeclass(this.content.dom,'list',true);
		changeclass(this.content.dom,'fullscreen',true);
	},
	
	showtopnav:function() {
		this.showpanel(this.topnav,true);
		this.showpanel(this.bottomnav,false);
		this.showpanel(this.tool,false);
		changeclass(this.content.dom,'list',true);
		changeclass(this.content.dom,'fullscreen',true);
		changeclass(this.content.dom,'tool',true);
		
		// also update the little dashboard in the top nav
		var d=document.getElementById('minidash');
		d.innerHTML=user.getminidash();
	},
	
	showlist:function() {
		changeclass(this.content.dom,'list');
		changeclass(this.content.dom,'fullscreen',true);
	},

	init:function() {
	},
};

panel.init();




//	var fr=document.getElementById('frame');
//	fr.style.width=window.w + 'px';
//	fr.style.height=window.h + 'px';
/*
var thumbnail=document.getElementById('picture');

var init=function() {
	var c=document.getElementById('cam');
	c.addEventListener('click',showcamera);
	checkgeo();
	// get weather info?
};
*/



/* GET ACTIVITY DATA */

var activitydata; // hash of activiy info
var lists; // list of groups of five to mete out
var allids; // list of all ids

var loadactivities=function(url,success) {
		var url='js/activities.json';

		var rq=new XMLHttpRequest();
		rq.open("GET",url,true);
		rq.onreadystatechange=function() {

			if(rq.readyState === XMLHttpRequest.DONE) {
           // alert(reqdata.responseText);


			//activitydata=JSON.parse(reqdata.responseText);
			success(rq.responseText);
       	 }
		}
		
		rq.send();
};

loadactivities('js/activities.json',function(responseText) {
	var ad=JSON.parse(responseText);
	activitydata=ad.activities;
	allids=[];
	for(var l in activitydata) {

		allids.push(l);
	}

	lists=ad.lists;
	



	cards.drawcards(user.whichdailies(lists.length));
	user.updatemissionlists();
	nav.home();

	search.makeindex(activitydata);	

	
	//cards.showcards();
	//panel.shownav();

});


/* INDEX PAGE */

var index={
	refresh:function() {
		this.activate();
	},
	
	finishlist:function() {
		nav.list('open');
	},
	
	finishsingle:function() {

		nav.single(user.missionstatus.open[0]);	
	},
	
	fulllist:function() {
		nav.list();
	},

	activate:function() {
		var b=document.getElementById('showcards');
		/*b.addEventListener(app.releasetype,function() {panel.shownav();cards.showcards();});*/

		if(b) {
			taketaps(b,'click',nav.cards);
		}
		
		var c=document.getElementById('inprogress');
		if(c) {

			var count=user.missionstatus.open.length;
			changeclass(c,'disabled',count > 0);
			if(count>0) {
				var amount=count + " Missions";
				if(count==1) {
					amount="1 Mission";
				}
			if(count==1) {
				cleartaps(c,'click',this.finishlist);
				taketaps(c,'click',this.finishsingle);
			} else {
				cleartaps(c,'click',this.finishsingle);
				taketaps(c,'click',this.finishlist);
			}
			c.innerHTML=amount+" in Progress"
			} else {
				c.innerHTML="No Missions in Progress";
				cleartaps(c,'click',this.finishlist);
				cleartaps(c,'click',this.finishsingle);
			}
		}
		
		var a=document.getElementById('allmissions');
		if(a) {
			taketaps(a,'click',this.fulllist);
		}
		
		var d=document.getElementById('dashboard');
		if(d) d.innerHTML=this.getdashboard();
		
		taketaps(d,'click',user.showalldata);
	},
	
	getdashboard:function() {
		// look up user's history
		
		//var c=user.missionstatus.completed.length;
		var c=user.loaddata('overall','totalmissions');
		if(!c) c=0;
		var o=user.missionstatus.open.length;
		
		var p=user.loaddata('overall','points');
		
		// greeting can change based on whether user has been here before, time of day, weather..?
		
		var greeting="Welcome!";
			
		if(p || p===0) {
			greeting="Welcome Back!";
		}
		
		var today=new Date(Date.now());
		var tod=today.getHours();
		//tod.getHours();
			//.getHours();

			if(tod < 4) {
				greeting="Go to sleep!";
			} else if(tod < 12) {
				greeting="Good morning!";
			} else if(tod < 17) {
				greeting="Good afternoon!";
			} else if(tod < 20) {
				greeting="Good evening!";
			} else if(tod < 24) {
				greeting="Ah, nighttime!";
				}
			

		
		var dash="<h1>"+greeting+"</h1>";
		dash+="<div id=\"weather\">"+weather.showweather() + "</div>";

		dash+="<img src=\"img/home_plum.png\" id=\"plum\"/>";
		
		dash+="<div id=\"pointstatus\" class=\"pointsbox\">";
		/*
		if(o>0) {
				dash+='<span class="act_open">';
			if(o==1) {
				dash+="1 open mission";
			} else {
				dash+=o + " open missions";
			}
				dash+='</span>';
		}
		*/
	
		
		dash+='<span class="act_open">' + c + ' mission'+s(c) + '</span>';
		if(!p) p=0;
		dash+='<span class="act_points">'+p + ' point'+s(p)+'</span>';

		dash+="</div>";
		// also set the mission date
		var dd=document.getElementById('today');
		if(dd) {
			dd.innerHTML=datenames.months[today.getMonth()] + " " + today.getDate();
		};

		return dash;
	},
	
	init:function(){
		this.activate=this.activate.bind(this);
	}
};

var showback=function(config) { // pass either 'false' (to hide) or a function to be run from the back button (or null)
	var bb=document.getElementById('backbutton');
	if(bb) {
		var hide=(config!==false);

		changeclass(bb,'hidden',hide);
		if(config) {

			taketaps(bb,'click',config);
		} else {
			taketaps(bb,'click',nav.back);
		}
	}
};

var showhome=function() {
	taketaps(panel.home,'click',nav.home);
};

var nav={
	history:[],
	last:'',
	current:'',
	home:function() {
		this.go('home');
	},
	list:function(type) {
		this.go('list',type);
	},
	cards:function() {
		this.go('cards');
	},
	single:function(id) {
		this.go('single',id);
	},
	parents:function() {
		nav.go('parents');
	},
	done:function(id) {
	// don't add it to the 'back' history, just record it
/*		tools.showtool(true);	
		panel.shownav();
		panel.setpanel(panel.bottomnav,'okay');
		panel.setpanel(panel.content,'completed');
		showback(false);
*/
		this.go('done',id);
		
	},
	back:function() {

		if(this.current[0]=='pick') {

			// special case when going back from a picked card, depending on where we came from before that. Either it goes back to the list, or back to the carousel
			var to=this.history.pop();

			switch(to[0]) {
				case 'single':
				to=this.history.pop();
				this.go(to[0],to[1]);
				this.history.pop();
				break;
				
				case 'cards':
//				cards.showcards();
				this.cards();
				this.history.pop();
				break;
			}
			
		} else {

			var to=this.history.pop();
			this.go(to[0],to[1]);
			this.history.pop();
		}
	},
	go:function(where,options) {
		this.from=this.current;
		this.history.push(this.from);

		this.left(this.from[0],this.from[1]);
		switch(where) {
			case 'home':
	//			cards.leavecards();
				panel.fullscreen();
				panel.setpanel(panel.content,'index');
				index.activate();
			break;
			
			case 'list':
	//			cards.leavecards();
				panel.showtopnav();
				panel.showlist();
				listview.type='mech';
				if(options) {
					listview.type=options; // could be 'open';
				}
				panel.setpanel(panel.content,'list');
				listview.activate();
				showback();
				showhome();
			break;
			
			case 'cards':	
				panel.shownav();
				cards.showcards();
				showhome();	
			break;
			
			case 'single':
					var id=(options)?options:app.mission;
					app.mission=id;
					cards.singlecard(id);
					panel.shownav();
					showback(); // sometimes you get here from the home screen
					showhome();	
			break;
			
			case 'pick':
				tools.showtool();
			break;
			
			case 'done':
				tools.showtool(true);	
				panel.shownav();
				panel.setpanel(panel.bottomnav,'okay');
				panel.setpanel(panel.content,'completed');
				showback(false);
			break;
			
			case 'stat':

			if(options) {
				panel.showtopnav();
				panel.showlist();
				panel.setpanel(panel.content,'stats');
				var l=document.getElementById('list');

				if(l) {
				var output='';
				for(var opt in options) {
					output+=options[opt] + "\n";
				}
				
				output+='<button id="clear">CLEAR DATA</button>';
					l.innerHTML=output;
					
					var bt=document.getElementById('clear');
					taketaps(bt,'click',user.cleardata);
					};
				showback();
				
				showhome();	
			}
			break;
			
			case 'parents':
				panel.showlist();
				panel.showtopnav();
				panel.setpanel(panel.content,'parents');
				showback();
				showhome();	
			break;
		}

/*		var navlog=user.loaddata('overall','nav');
		if(!navlog) navlog=[];
//		user.savedata('overall','nav',navlog,true);
*/

		var n=where;
		if(options) {n=[n,options];}
		logdata.nav(n);
		this.current=[where,options];
	},
	left:function(where,options) {
		// clean up whatever we left from]
		if(where=='cards') {	
			cards.leavecards();
		}
		if(where=='pick') {

			tools.showtool(true);
		}
	},
	init:function() {
		this.go=this.go.bind(this);
		this.back=this.back.bind(this);
		this.list=this.list.bind(this);
		this.home=this.home.bind(this);
		this.cards=this.cards.bind(this);
		this.single=this.single.bind(this);
	}
};
nav.init();


/*
var showcards=function() {
	nav.go('cards');
	panel.shownav();
	cards.showcards();
};


var showopen=function() {
	cards.leavecards();
	panel.showtopnav();
	panel.showlist();
	listview.type='open';
	panel.setpanel(panel.content,'list');
	listview.activate();
	showback();
};

var showlist=function() {
	nav.go('list');
	cards.leavecards();
	panel.showtopnav();
	panel.showlist();
	listview.type='all';
	panel.setpanel(panel.content,'list');
	listview.activate();
	showback();
};*/

index.init();

/* ACTIVITY LIST */

var listview={
	type:'all',
	scrollpos:0,
	open:[],
	completed:[],
	seen:[],
	listed:[],
	searchbox:null,
	suggest:null,
	
	activitylist:function() {
	/*	
		this.open=[];
		this.completed=[];
		this.seen=[];
		
	
		for(var a in activitydata) {
			var id=a;
			var status=user.showstatus(id);
			switch(status) {
				case user.status.seen:
				this.seen.push(a);
				break;
				
				case user.status.open:
				this.open.push(a);
				break;
				
				case user.status.done:
				this.completed.push(a);
				break;
			}
		}
		
		*/
		
		
		var html="";
		var title="";
		var listsource;
		this.listed=[];
		if(this.type=='open') {
			if(user.missionstatus.open.length > 0) {
			title="<h2>Missions in Progress</h2>";
			listsource=user.missionstatus.open;
			html+=title;
			html+=this.makelist(listsource);
			}
		} else {
			// sort by mechanic
			var listset={};
			for(var a in activitydata) {
				var tool=activitydata[a].tool;
				if(!listset[tool]) listset[tool]=[];
				listset[tool].push(a);
			}
			
			for(var t in listset) {
				html+="<h2>"+tools.names[t]+" Missions</h2>";
				html+=this.makelist(listset[t]);
			}
			
		} 
		/*
		// complete list
			{
			title="<h2>Missions</h2>";
			listsource=allids;			


			html+=title + '<input type="text" id="search" name="search" /><div id=\"suggest\"></div><div id=\"activitylist\">';			
			html+=this.makelist(listsource);
			html+="</div>";
		}*/
		
		
		
//		html+=this.makelist(user.missionstatus.seen,"New Missions");
//		html+=this.makelist(user.missionstatus.completed,"Finished Missions");
		
//		changeclass(panel.content.dom,'list');
//		panel.showlist();		
		
		return html;
	},
	
	
	makelist:function(arr,title) {
		if(arr.length==0) return "";
	//	this.listed=[];
		var html="<ul class=\"act\">";
		for(var a in arr) {
			var id;
			if(arr[a].id) {
				id=arr[a].id;
			} else {
				id=arr[a];
			}
			this.listed.push(id);

			var title=activitydata[id].title;
			var status=user.showstatus(id);
			
			//if(status==user.status.unseen) continue;
			
			var button="";
			if(status==user.status.open) {
/*				button="<button id=\"b_"+id+"\" class=\"listbutton short bg-orange\">Finish</button>";	
*/
				button="<div class=\"liststatus listprogress\">IN PROGRESS</div>";
			} else if(status==user.status.done) {
				
//				button="<img class=\"listcomplete\" src=\"img/checkmark_dark.svg\" alt=\"\" width=\"15\" height=\"15\" /><button id=\"b_"+id+"\" class=\"listbutton short bg-ltgreen\">Again</button>";	

				button="<div class=\"liststatus listcomplete\"><img class=\"\" src=\"img/checkmark_light.svg\" alt=\"\" width=\"11\" height=\"11\" /></div>";
			} else {
			
			//	button="<button id=\"b_"+id+"\" class=\"listbutton short bg-green\">Open</button>";	
			}
			
//			var subtitle=activitydata[id].desc.substring(0,26);
			
/*			var img="FPO.png";

		var i=new Image();
		i.id=id;
		i.src="img/act/" + id + "_thumb.jpg";
		i.onload=function() {

			listview.putimage(this.id,this.src);
		}
*/
			var img=id + "_thumb.jpg";

			html+="<li id=\"s_"+id+"\"><img id=\"thumb_" + id+"\" src=\"img/act/"+img+"\" width=\"40\" height=\"40\" alt=\""+title+"\" class=\"listimage\"/><div class=\"label\"><span class=\"title\">" + title + "</span></div>" +button+"</li>";
		}
		html+="</ul>";
		return html;
	},
	putimage:function(id,src) {

		var i=document.getElementById('thumb_' + id);
		i.src=src;
	},
	
	activatebuttons:function() {
			var i,id,b;
		for(i in this.listed) {
			id=this.listed[i];
			b=document.getElementById('s_'+id);
			if(b) {
				taketaps(b,'click',this.choose);
			}
		}
	},
	
	activate:function() {


	
		taketaps(panel.home,'click',nav.home);
		this.activatebuttons();
	/*		
		
		for(i in this.listed) {
			id=this.listed[i];
			b=document.getElementById('b_'+id);
			if(b) {
				taketaps(b,'down',this.choose);
			}
		}
		
	for(id in activitydata) {
			b=document.getElementById('b_'+id);
			if(b) {
				taketaps(b,'down',this.choose);
			}
		}
		
		for(i in user.missionstatus.open) {
			id=user.missionstatus.open[i];

			b=document.getElementById('b_'+id);
			if(b) {
				taketaps(b,'down',this.choose);
			}
		}
		for(i in user.missionstatus.seen) {
			id=user.missionstatus.seen[i];		
			b=document.getElementById('b_'+id);
			if(b) {
				taketaps(b,'down',this.choose);
			}
		}
		for(i in user.missionstatus.completed) {
			id=user.missionstatus.completed[i];
			b=document.getElementById('b_'+id);
			if(b) {
				taketaps(b,'down',this.choose);
			}
		}
		*/
		
		
		/*

// SKIP THE SEARCH
		this.searchbox=document.getElementById('search');
		if(this.searchbox) {
			this.searchbox.addEventListener("change",this.runsearch);
			this.searchbox.addEventListener("input",this.presearch);
			
			this.suggest=document.getElementById('suggest');
		}

*/
		
		var list=document.getElementById('list');
		list.scrollTop=this.scrollpos;
	
		list.removeEventListener('scroll', inscroll);
		list.addEventListener('scroll', inscroll);
		
	},
	
	
	
	presearch:function() {
		var searchterm=this.searchbox.value;
		this.suggest.innerHTML='';
		if(searchterm!='') {
//			window.alert(searchterm);
			var ac=search.autocomplete(searchterm);


//			var sug='';
			var sug;
			for(var w in ac) {
				sug=document.createElement('a');
				sug.attributes.dataword=ac[w];
				sug.innerHTML=ac[w];
				taketaps(sug,'click',this.picksearch);
//				sug+="<span data-word=\""+ac[w] + "\">"+ac[w]+"</span><br />";
				this.suggest.appendChild(sug);
			}
//			this.suggest.innerHTML=sug;
		}
	},
	
	picksearch:function(ev) {
		this.searchbox.value=ev.target.attributes.dataword;
		this.runsearch();
	},
	
	runsearch:function() {
		this.suggest.innerHTML="";
		var searchterm=this.searchbox.value;
		var l=document.getElementById('activitylist');
		if(searchterm=='') {
			// show all
			this.listed=[];
			l.innerHTML=this.makelist(allids);
		} else {
			var res=search.search(searchterm);

			this.listed=[];
			l.innerHTML=this.makelist(res);
		}
		this.searchbox.blur();
		this.activatebuttons();
	},
	
	choose:function(ev) {
	
		var list=document.getElementById('list');
		this.scrollpos=list.scrollTop;
		
		var id=ev.currentTarget.id.split("_")[1];

		this.teardown();
//		app.mission=id;
//		cards.singlecard(id);
//		panel.shownav();
		nav.single(id);
		if(this.type=="open") {
			cards.backdo=3;
		} else {
		
			cards.backdo=2;
		}
	},
	
	init:function() {
		this.presearch=this.presearch.bind(this);
		this.runsearch=this.runsearch.bind(this);
		this.picksearch=this.picksearch.bind(this);
		this.activitylist=this.activitylist.bind(this);
		this.choose=this.choose.bind(this);
	},
	teardown:function() {

		cleartaps(panel.home,'click',nav.home);
		
		for(i in this.listed) {
			id=this.listed[i];
			b=document.getElementById('b_'+id);
			if(b) {
				cleartaps(b,'click',this.choose);
			}
		}
		
		/*
		
		var id,b,i;
		for(i in this.completed) {
			id=this.completed[i];
			b=document.getElementById('b_'+id);
			if(b) {
				cleartaps(b,'down',this.choose);
			}
		}
				for(i in this.open) {
			id=this.open[i];
			b=document.getElementById('b_'+id);
			if(b) {
				cleartaps(b,'down',this.choose);
			}
		}		for(i in this.seen) {
			id=this.seen[i];
			b=document.getElementById('b_'+id);
			if(b) {
				cleartaps(b,'down',this.choose);
			}
		}
		
		*/
		
//		cleartaps(panel.content.dom,'down',this.dragcard);
//		cleartaps(panel.content.dom,'move',this.dodrag);
//		cleartaps(panel.content.dom,'up',this.leggo);
	}

};

listview.init();


/* ACTIVITY CARD FUNCTIONS */

var cards={

	cardids:[], // the set of cards chosen from the full deck
	carddots:[], // the little dots showing which card you're on
//	startbuttons:[], // each card has its own start button
	handsize:0,
	lastcard:0,
	cardnum:0,
	dailylist:0,
	backdo:1, // what to do when "back" is clicked
	
	setdots:function() {
		var dotset=document.getElementById('carddots');
		var dots="";
		for(var d=1;d<=this.handsize;d++) {
			dots+='<div class="carddot" id="d' + d+'"></div>';
			
			
			
		}
		dotset.innerHTML=dots;
		this.carddots=[];
//		this.startbuttons=[];
		for(var d=0;d<this.handsize;d++) {
			var j=d+1;
			this.carddots[d]=document.getElementById('d' + j);
//			var startbutton=document.getElementById('start_' + this.cardids[d]);

//			taketaps(startbutton,'down',this.choosecard);
//			this.startbuttons.push(startbutton);
			this.setbutton(this.cardids[d],true,this.choosecard);
		}
		
		this.backdo=1;
		
	},

	showcards:function(whatcard) {
		var lastc=user.whichdailies(lists.length);

		if(lastc!=this.dailylist) {
			this.drawcards(lastc);
		}

		// set up the first card, prepare the others. Show the arrows to go back and forth.
//		this.cardids=[];
		var cardholder='<div id=\"allcards\" class=\"cardset transit\">';


//		taketaps(panel.home,'click',nav.home);

/*		for(var act in activitydata) {
			// eventually pick a subset
			var card=this.makecard(act,activitydata[act]);
			this.cardids.push(act);
			cardholder+=card;
		}
*/

		for(var a in this.cardids) {
			var id=this.cardids[a];
			var card=this.makecard(id);
			cardholder+=card;
			
		}
		
		
		cardholder+="</div>";
		
		panel.content.dom.innerHTML=cardholder;
		panel.content.active='cards';
		
		this.cardset=document.getElementById('allcards');
		
		
		
//		panel.content.dom.addEventListener(app.taptype,this.dragcard);

		//taketaps(panel.content.dom,'down',this.dragcard);
		
//		this.right=document.getElementById('arrowright');
//		this.right.addEventListener(app.taptype,this.nextcard);
		
//		this.left=document.getElementById('arrowleft');
//		this.left.addEventListener(app.taptype,this.prevcard);
		
		
		this.startleft=0;
		this.startdrag=0;
		this.diff=0;
		this.cardid=0;
	
	
//		this.start=document.getElementById('start');
//		this.start.addEventListener(app.taptype,cards.choosecard);
	
		panel.setpanel(panel.bottomnav,'carousel');
		this.setdots();
		
		whatcard=whatcard?whatcard:this.cardnum;
		
		this.setcard(whatcard);
		
		showback();
	},
	
	drawcards:function(set) {
		// choose the 5(?) cards that will be displayed
		this.cardids=[];
		var fulldeck=[];


// draw from all:
/*
		for(var act in activitydata) {
			fulldeck.push(act);
		}	
		this.handsize=Math.min(fulldeck.length,3);
		for(var i=0;i<this.handsize;i++) {
			// draw 5
//			var rn=parseInt(Math.random() * fulldeck.length);
			var rn=0;
			var draw=fulldeck.splice(rn,1);
			this.cardids.push(draw);
		}
*/
		this.dailylist=set;
		var list=lists[this.dailylist];
		
		this.handsize=list.length;
		for(var id in list) {
			this.cardids.push(list[id]);
		}
		this.lastcard=this.handsize-1;
	},

	makecard:function(id) {
		if(id=='id') id=app.mission;
		// make a card (DOM element? string?) out of an activity

		var activity=activitydata[id];

		
		/*
		var action="Do this!";
		var st=user.showstatus(id);

		if(st==user.status.done) {
			action="Do this again!";
		} else if(st==user.status.open) {
			action="Finish this";
		}
		*/
		// image for the card has to be in img/act/
/*		
		var img="FPO.png";
		
		var i=new Image();
		i.src="img/act/" + id + ".jpg";
		i.onload=function() {

			cards.putimage(id,this.src);
		}
*/
		var img=id +".jpg";

		var cd='<div class="actcard" id="'+id+'"><img class="actimage" src="img/act/' + img+ '" id="hero_'+id+'" alt="'+activity.title+'" width="195" height="195" /><div class="acttitle">' + activity.title + '</div><div class="actdesc">' + activity.desc + '</div><div class="cardbuttons"><button id="start_'+id+'" class="cardbutton"></button></div></div>';
		
//		<div class=\"acttool\">[" + activity.tool + "]</div></div>"
		
		return cd;
	},
	putimage:function(id,src) {
		var i=document.getElementById('hero_' + id);
		i.src=src;
	},
	goback:function() {

		switch(this.backdo) {
			case 1: // back to the carousel
				panel.setpanel(panel.bottomnav,'carousel');
				// may need to reset the current card
						
				this.setcard(this.cardnum);
			break;
			
			case 2:
			// go back to the full list
//				panel.setpanel(panel.bottomnav,'carousel');
//				this.setcard(this.cardnum);
			nav.list('mech');
			break;
			
			case 3:
			// go back to the short list
//				panel.setpanel(panel.bottomnav,'carousel');
//				this.setcard(this.cardnum);
			nav.list('open');
			break;
		
		}
	},
	nextcard:function() {
		this.showcard(this.cardids[this.cardnum],true); // return current card to detente
		this.setcard(this.cardnum+1);
	},
	
	prevcard:function() {
		this.showcard(this.cardids[this.cardnum],true); // return current card to detente
		this.setcard(this.cardnum-1);
	},
	
	setcard:function(newcard) {

		if(newcard<0) {this.cardnum=0;}
		else if(newcard>this.lastcard) this.cardnum=this.lastcard;
		else this.cardnum=newcard;

		changeclass(panel.bottomnav.ui.arrowleft,'disabled',this.cardnum>0);
		changeclass(panel.bottomnav.ui.arrowright,'disabled',this.cardnum<this.lastcard);
	
		this.positioncard();
		for(var c=0;c<this.handsize;c++) {
			changeclass(this.carddots[c],'select',c!=this.cardnum);
		}
		this.cardid=this.cardids[this.cardnum];
	},
	
	positioncard:function() {
		this.cardset.style.left=(this.cardnum * -100) + "%";
		changeclass(this.cardset,'transit');
//		changeclass(panel.bottomnav.ui.start,'invisible',true);
		this.showcard(this.cardids[this.cardnum],true);
		user.seemission(this.cardids[this.cardnum]);
		
		
	},
	
	choosecard:function(ev) {
		//changeclass(this.start,'invisible');
		cleartaps(panel.content.dom,'down',this.dragcard);
		cleartaps(panel.content.dom,'move',this.dodrag);
		cleartaps(panel.content.dom,'up',this.leggo); // stop the move/drag bit


		
//		this.cardid=this.cardids[this.cardnum];
		app.mission=this.cardid;

		// when choosing a card, hero image goes away and more information appears. Also the tool panel appears.

		
		// get the image child of this card and shrink it
		
		this.showcard(this.cardid);
		
		panel.setpanel(panel.bottomnav,'activity');
		
		
		//changeclass(panel.bottomnav.ui.complete,'disabled');
		
		// make the app aware of which card is chosen
		
		this.checkcompletion(tools[activitydata[app.mission].tool].progress);
		
		// save that the user has chosen this
		user.openmission(app.mission);

		nav.go('pick',app.mission);
		
//		user.savedata(app.mission,'status','open');
	},
	
	setbutton:function(cardid,hide,tapfunction) {
		var startbutton=document.getElementById('start_' + cardid);
		if(hide===false) {

			changeclass(startbutton,'hidden');
			return;
		}
		


		var st=user.showstatus(cardid);
			if(st==user.status.done) {
				startbutton.innerHTML="Do this again!";
			} else if(st==user.status.open) {
				startbutton.innerHTML="Finish this";
			} else {
				startbutton.innerHTML="Do this one!";
			}
			if(tapfunction) {
				taketaps(startbutton,'click',tapfunction);
			}
			changeclass(startbutton,'hidden',true);
	},
	
	showcard:function(cardid,orhide) {
		//var card=document.getElementById(cardid);


		var heroimage=document.getElementById('hero_'+cardid);
		changeclass(heroimage,'flat',orhide);
		changeclass(panel.content.dom,'tool',orhide);

		
		var carddom=document.getElementById(cardid);
		var desc=carddom.childNodes[2];
		if(orhide) {
			desc.innerHTML=activitydata[cardid].desc;
			changeclass(carddom,'big',true);
			this.setbutton(cardid);
			taketaps(panel.content.dom,'down',this.dragcard);

			this.setdots();
			
		} else {

		//	var carddom=document.getElementById(this.cardid);
			changeclass(carddom,'big');
		//	changeclass(startbutton,'hidden');
			this.setbutton(cardid,false);
			desc.innerHTML=activitydata[cardid].full;	
		}
		
		var thiscard=document.getElementById(cardid);
		thiscard.appendChild(panel.tool.dom);

		tools.showtool(orhide);
		
	//	panel.setpanel(panel.bottomnav,'carousel');
		
	//	this.start.innerHTML=activitydata[cardid].title;
	},
	
	singlecard:function(id) {

		app.mission=id;
		this.cardid=id;
		
		
		if(user.showstatus(id)==user.status.open) {

			this.opencard(id);
		} else {
//			var cardholder='<div id=\"allcards\" class=\"cardset transit\">' + this.makecard(id) + '</div>';

			panel.setpanel(panel.content,'singlecard');
			panel.setpanel(panel.bottomnav,'blank');
			showback();
//			taketaps(panel.home,'click',nav.home);
			this.setbutton(id,true,this.choosecard);
//			var startbutton=document.getElementById('start_' + id);

//			taketaps(startbutton,'down',this.choosecard);
			// hide the "complete"
			var co=document.getElementById('complete');
			changeclass(co,'hidden');
			
			tools.showtool(true);
			this.checkcompletion(tools[activitydata[app.mission].tool].progress);
		}
		
		var thiscard=document.getElementById(id);
		thiscard.appendChild(panel.tool.dom);
	},
	
	opencard:function(id) {

//		taketaps(panel.home,'click',nav.home);
	//	cards.showcard(id);
		app.mission=id;
		var onecard="<div class=\"singlecard\">"+ this.makecard(id) + "</div>";
		panel.shownav();
		
		
		panel.content.active='cards';
		panel.content.dom.innerHTML=onecard;
		
		var thiscard=document.getElementById(id);
		thiscard.appendChild(panel.tool.dom);
		tools.showtool();
		
		changeclass(document.getElementById('start_'+id),'hidden');
		changeclass(document.getElementById(id),'big');
		//this.showcard(id,true);
		
		var desc=thiscard.childNodes[2];
		desc.innerHTML=activitydata[id].full;
		
		panel.setpanel(panel.bottomnav,'activity');
//		this.backdo=2;
		
		var heroimage=document.getElementById('hero_'+id);
		changeclass(heroimage,'flat');
		
		
		var co=document.getElementById('complete');
		changeclass(co,'hidden',true);
			
		this.checkcompletion(tools[activitydata[app.mission].tool].progress);
			
	},
	
	done:function() {
		// flip the card? somewhat tricky because dimensions need to be specified
		var card=document.getElementById(app.mission);
//		changeclass(card,'complete');

//		user.savedata(app.mission,'status','complete');

		nav.done(app.mission);


		user.completemission(app.mission);
		
	//	card.innerHTML=templates.completed.html;
	},

	rate:function(rating) {

		user.savedata(app.mission,'rating',rating);
		nav.home();
	},
	
	
	checkcompletion:function(percentage) {
		// check to see whether the current state is completable
		var tf=percentage>=1;
		tf=true;
		var co=document.getElementById('complete');
		changeclass(co,'disabled',tf);
		return tf;
	},
	
	
	cardinfo:function(id) {
	},
	
	dragcard:function(ev) {


		panel.setpanel(panel.bottomnav,'carousel');
		this.startdrag=app.getcoords(ev,true).x;
		this.diff=0;
		this.startleft=this.cardset.style.left ? parseInt(this.cardset.style.left):0;
		
//		panel.content.dom.addEventListener(app.dragtype,this.dodrag);
//		panel.content.dom.addEventListener(app.releasetype,this.leggo);

		taketaps(panel.content.dom,'move',this.dodrag);
		taketaps(panel.content.dom,'up',this.leggo);
		
		changeclass(this.cardset,'transit',true);
	},
	
	dodrag:function(ev) {


		this.diff=app.getcoords(ev,true).x-this.startdrag;

		this.cardset.style.left=(this.startleft + this.diff*app.pixelratio) + "%";
	},
	
	leggo:function(ev) {

		cleartaps(panel.content.dom,'move',this.dodrag);
		cleartaps(panel.content.dom,'up',this.leggo);
		
//		panel.content.dom.removeEventListener(app.dragtype,this.dodrag);
//		panel.content.dom.removeEventListener(app.releasetype,this.leggo);
		// snap card to nearest
		
		// if moved more than 1/2 toward the next one, should move it over
		
//		var dir=(this.startleft-this.diff)>0?1:-1;
		var dir=this.diff>0?1:-1;

		var move=50-(dir*30);
		var nleft=parseInt((parseInt(this.cardset.style.left)-(move))/-100);
		this.setcard(nleft);
		},
		
		
	init:function() {
		// for swiping
		this.dragcard=this.dragcard.bind(this);
		this.dodrag=this.dodrag.bind(this);
		this.leggo=this.leggo.bind(this);

		// back button		
		this.goback=this.goback.bind(this);
		
		this.setdots=this.setdots.bind(this);
		
		// previous/next
		this.prevcard=this.prevcard.bind(this);
		this.nextcard=this.nextcard.bind(this);
		
		// chosen
		this.choosecard=this.choosecard.bind(this);
		
		this.makecard=this.makecard.bind(this);
		
		this.currentid=this.currentid.bind(this);
	},
	
	currentid:function() {
		return app.mission;
	},
	
	currentresults:function() {
		if(!tools[activitydata[app.mission].tool].results) return "";
		var ret=tools[activitydata[app.mission].tool].results(app.mission);
		return ret;
	},
	
	tallyup:function(points,add,bonus) {
		// 
		var pts=document.getElementById('newpoints');
		var mini=document.getElementById('minidash');
		var start=0;
		var dest=add;
		var ministart=points;
		var perc=0;
		var dur=300;
		var now=Date.now();
		var me=this;
		var ok=document.getElementById('okay');
		var b=document.getElementById('bonus');
		var count=function() {
			var newnow=Date.now();
			perc=(newnow-now)/dur;
			tally=start + (dest-start)*perc;
			if(tally<dest) {
				setTimeout(count,50);
			} else {
				tally=dest;
				if(bonus) {
					
				pts.innerHTML=parseInt(tally) + " points";
				mini.innerHTML=parseInt(tally+ministart) + " points";
			//tween.start(mini,'innerHTML',tally+ministart,tally+ministart+50,500);
					setTimeout(function() {
						
					changeclass(ok,'disabled',true);
					soundtrack.play('ding');
					pts.innerHTML="+50 points";
					mini.innerHTML=parseInt(tally+ministart+50) + " points";	
					b.innerHTML="NEW MISSION BONUS";
					},1250);
					
				} else {
					changeclass(ok,'disabled',true);
				}
			}
			pts.innerHTML=parseInt(tally) + " points";
			mini.innerHTML=parseInt(tally+ministart) + " points";			
		};
		count();
	},
	bonustally:function() {
		
		var pts=document.getElementById('newpoints');
		var mini=document.getElementById('minidash');
		
		
	},
	
	leavecards:function() {

		tools.showtool(true);

		cleartaps(panel.content.dom,'down',this.dragcard);
		cleartaps(panel.content.dom,'move',this.dodrag);
		cleartaps(panel.content.dom,'up',this.leggo);
	}
};

var tween={
	starttime:0,
	dur:0,
	val:0,
	begin:0,
	end:0,
	range:0,
	prop:0,
	start:function(object,property,start,end,duration) {
		this.starttime=Date.now();
		this.dur=duration;
		this.val=0;
		this.begin=start;
		this.end=end;
		this.range=end-start;
		this.object=object;
		this.property=property;
		this.tick=this.tick.bind(this);
		this.tick();
	},
	tick:function() {


			var newnow=Date.now();
			var perc=(newnow-this.starttime)/this.dur;
			this.val=this.begin + (this.range)*perc;
			if(this.val < this.end) {
				setTimeout(this.tick,50);
			} else {
				this.val=this.end;
			}
			this.object[this.property]=this.val;
		}
//	t.tick();
};


var animate=function(key,startval,endval,duration) {
	if(!key) return;
	key=startval;
	starttime=Date.now();
	setInterval();
}

cards.init();

/* TOOLS */

var tools={
	open:document.getElementById('expand'),
	enlarged:false,
	whichtool:null,
	names:{
	'camera':"Camera",
	'timedcounter':"Timed Counter",
	'scavenger':"Scavenger Hunt",
	'counter':"Counter",
	'timer':"Timer",
	'stopwatch':"Stopwatch",
	'none':"Low Tech"
	
	},
	
	showtool:function(orhide) {
		// if tool should be shown, set to open.
	//	changeclass(panel.tool,'openfull',true);
	//	changeclass(panel.tool,'open',orhide);
		
		if(!app.mission || activitydata[app.mission].tool=='none') {
			orhide=true;
		} 
		
		if(!orhide) {
		
			this.whichtool=tools[activitydata[app.mission].tool];
			
/*
			var thiscard=document.getElementById(app.mission);
			thiscard.appendChild(panel.tool.dom);
*/	
			this.smalltool();
			if(this.whichtool.launch) this.whichtool.launch(); // do this before setting the visuals, in case visuals require something
			panel.setpanel(panel.tool,activitydata[app.mission].tool,true); // sometimes this doesn't set the panel again...override with "true"
			if(this.whichtool.activate) this.whichtool.activate();
		} else {
			changeclass(panel.tool.dom,'fullopen',true);
			changeclass(panel.tool.dom,'open',true);
			// also teardown the tool
			if(this.whichtool && this.whichtool.teardown) this.whichtool.teardown();
		}
	},
	largetool:function() {
		//changeclass(panel.tool,'open',orshrink); // if it's shrinking, set it to 
		changeclass(panel.tool.dom,'fullopen');

//		this.open.removeEventListener(app.taptype,this.largetool);
//		this.open.addEventListener(app.taptype,this.smalltool);
		cleartaps(this.open,'click',this.largetool);
		taketaps(this.open,'click',this.smalltool);
		this.enlarged=true;
	},
	smalltool:function() {
		changeclass(panel.tool.dom,'fullopen',true);
		changeclass(panel.tool.dom,'open');
		cleartaps(this.open,'click',this.smalltool);
		taketaps(this.open,'click',this.largetool);
		
//		this.open.removeEventListener(app.taptype,this.smalltool);
//		this.open.addEventListener(app.taptype,this.largetool);
		this.enlarged=false;
	},
	init:function() {
		this.largetool=this.largetool.bind(this);
		this.smalltool=this.smalltool.bind(this);
	}
	
};

tools.init();

/* CAMERA FUNCTIONS */

tools.camera={
	whichpic:0,
	lastpic:4,
	progress:0, // determines the progress toward completion
	picarray:[],
	showcamera:function() {
		this.close();
		navigator.camera.getPicture(this.success, this.error, this.options);
	},

	options:{
		targetWidth:720,
		targetHeight:720, // 960 seems big enough and not too big - just under 1 megapixel... although it does make the animation a little sluggish
		saveToPhotoAlbum:true
//cameraDirection:Camera.Direction.FRONT [or] Camera.Direction.BACK
	},
	
	success:function(image) {
//		alert('success');
//		var im=panel.tool.ui["p"+ (camera.whichpic+1)];
//		im.innerHTML="<img src=\"img/checkmark.svg\" class=\"icon\" />";
		
		var im=panel.tool.ui["i"+(this.whichpic+1)];
		
		im.src=image;
//		alert("capture image " + image);
		im.unfilled=false;
		var saveimage=image;
		if(app.ondevice) {
			var opendate=user.loadfromopenmission(app.mission,'open');
			var imagefile=app.mission + "_" + logdate(opendate,'second') + "_" + zeropad((this.whichpic+1),3) + ".jpg";
			saveimage=io.keepimage(image,imagefile);
		}
		
//		var im=new Image();
//		im.style.width="100%";
//		panel.tool.ui["p"+ (camera.whichpic+1)].appendChild(im);
//		im.src=image;

		this.picarray[this.whichpic]=saveimage;
		this.whichpic++;
		if(this.whichpic>this.lastpic) this.whichpic=this.lastpic;

		var copyarray=[];
		for(var p in this.picarray) {
			copyarray.push(this.picarray[p]);
		}
		user.savetoopenmission(app.mission,'photos',copyarray);
		this.progress=this.whichpic/this.lastpic;
		cards.checkcompletion(this.progress);
	},
	error:function(error) {
		//alert(error);
	},
	
	enlarge:function(ev) {
		// look at the target object's image's src, if it has one

		//var im=ev.target; // .target may be the image, as opposed to currentTarget which is always the button.
		
		var im=ev.currentTarget.childNodes[0];
		
		if(!im.src || im.unfilled) {this.close();return};

		if(tools.enlarged) {
			panel.tool.ui.ilarge.src=im.src;
//			tools.smalltool();
//			camera.enlarged=false;
		} else {
			tools.largetool();
			panel.tool.ui.ilarge.src=im.src;
		}
	},
	close:function() {
		tools.smalltool();
	},
	init:function() {
		this.enlarge=this.enlarge.bind(this);
		this.showcamera=this.showcamera.bind(this);
		this.success=this.success.bind(this);
	},
	teardown:function() {

	},
	activate:function() {
		var savedpics=user.loadfromopenmission(app.mission,'photos');
		this.picarray=[];
		for(var i=0;i<5;i++) {
			var im=panel.tool.ui["i"+(i+1)];
			if(savedpics&&savedpics[i]) {
				this.picarray.push(savedpics[i]);
				im.src=io.getURL(savedpics[i]);
				im.unfilled=false;
			} else {
				im.src="img/blank.png";
				im.unfilled=true;
				/*
				//for debug on web
				if(i==0) {
				
				im.src="img/app-bg.png";
				im.unfilled=false;
				} else if(i==1) {
				
				im.src="img/act/apple.jpg";
				im.unfilled=false;
				}
				*/
			}
		}
		this.whichpic=this.picarray.length;
		this.progress=this.whichpic/this.lastpic;
	},
	
	results:function(id) {
		// show the results of a camera-type mission
		var savedpics=user.loadfromopenmission(id,'photos');
		//savedpics=[1,2,3,4,5];
		var result='';
		if(savedpics) {
		result+='<div id="imgresult" class="fullctr">';
		for(var i in savedpics) {
			var src=io.getURL(savedpics[i]);
			//var src="img/act/findleaves.jpg";
			result+="<div class=\"f1_8 col\"><img class=\"thumbnail imgresult\" src=\"" +  src + "\"></div>";
		}
		result+="</div>";
		}
		return result;
	}
};
tools.camera.init();

/* COUNTER */

tools.counter={
	count:0,
	progress:0,
	subtract:function() {
		this.count--;
		this.progress=1;
		if(this.count<0) this.count=0;
		this.display();
	},
	add:function() {
		this.count++;
		this.progress=1;
		this.display();
	},
	reset:function() {
		this.count=0;
		this.progress=0;
		this.display();
	},
	display:function() {
		panel.tool.ui.cdisplay.innerHTML=this.count;
		cards.checkcompletion(this.progress);
		user.savetoopenmission(app.mission,'count',this.count);
		
		
	},
	init:function() {
		this.subtract=this.subtract.bind(this);
		this.add=this.add.bind(this);
		this.reset=this.reset.bind(this);
	},
	activate:function() {
		this.count=user.loadfromopenmission(app.mission,'count');
		if(this.count==null) {
			this.progress=0;
			this.count=0;} else {
			this.progress=1;
		}

		this.display();
	},
	results:function(id) {
		var count=user.loadfromopenmission(id,'count');
		var items=activitydata[app.mission].result.split('|');
		var item=(count==1)?items[0]:items[1];
		return "You found " + count + " " + item + ".";
	}
};
tools.counter.init();


/* TIMER */
tools.timer={ // tools for UI for a timer, but the timer itself (counting the time) will be a separate object

	progress:0,
	startedat:null, // will be a timestamp that the timer was started
	defaultstart:900, // if no start time is given this is the default?
	starttime:600,
	currenttime:0,
	targettime:0, // date in the future when the timer should end
	showtime:null, // display of the time
	startbutton:null, // stop/start button
	timeout:null, // 
	running:false,
	
	display:null, // DOM element to display the time
	togglestart:function() {
		if(this.usetimer.running) {
			this.stop();
		} else {
			this.start();
		}
	},
	

	start:function() {
		this.usetimer.start();
//		this.running=true;
//		this.startedat=Date.now();
//		this.targettime=20+parseInt(this.startedat+parseInt(this.currenttime)); // add a bit to adjust for rounding from ms

		clearInterval(this.timeout);
		this.timeout=setInterval(this.update,200);
		this.startbutton.innerHTML="Pause";
	},

	stop:function() {

		panel.tool.ui.tstart.innerHTML="Start";
		this.usetimer.stop();
//		this.running=false;
		clearInterval(this.timeout);
	},
	
	stoptimer:function(id) {
		// stop whatever timer may be running
		var ti=this.settimer(app.mission);
		ti.stop();
	},

	reset:function() {
		this.stop();
		this.usetimer.reset();
		changeclass(panel.tool.ui.tstart,'disabled',true);
		
//		this.stop();
//		this.currenttime=this.starttime;
		this.display();
	},
	update:function() {
//		this.currenttime-=1;
//		this.currenttime=this.targettime-Date.now();
		

//		if(this.currenttime<=0) {
//			this.timesup();
//		}
		this.display();
	},
	timesup:function() {
//		this.stop();
//		this.progress=1;
//		cards.checkcompletion(this.progress);
		this.stop();
		changeclass(panel.tool.ui.tstart,'disabled');
	},
	display:function() {
		// every .5 seconds update
		this.showtime.innerHTML=this.convert(this.usetimer.currenttime);
	},
	calibrate:function() {
		// every so often, calibrate against the start time in case of drift
		
	},
	activate:function() {
	// find out if I'm currently timing; if so, start from there.
	
		this.startbutton=panel.tool.ui.tstart;
		this.showtime=panel.tool.ui.tdisplay;
		this.progress=0;
	
		this.usetimer=this.settimer(app.mission);

		if(!this.usetimer.running) {
			//this.reset();
			this.startbutton.innerHTML="Start";
		} else {
			// continuing running from before
			this.startbutton.innerHTML="Pause";
		}
		this.display();
	},
	
	convert:function(ms) {
		// converts seconds to hours:minutes:seconds with zero padding on minutes (if there are any hours) and seconds. Only do hours if it's more than two hours.

		var num=Math.round(ms/1000);
		var minutes=parseInt(num/60);
		var seconds=parseInt(num%60);
		var anyhours="";
		if(minutes > 120) {
			var hours=parseInt(minutes/60);
			minutes=zeropad(minutes-(hours*60));
			anyhours=hours+":";
		}
		
		return anyhours + minutes + ":" + zeropad(seconds);
	},
	
	newtimekeeper:function(id) {
		
		var time=(activitydata[app.mission].time) ? activitydata[app.mission].time*1000 : 60 * 1000;
		
		var timer={
			id:id,
			starttime:time,
			startedat:null,
			running:false,
			currenttime:time,
			targettime:null,

			stop:function() {
				this.running=false;
				clearInterval(this.timeout);
			},

			start:function() {
				clearInterval(this.timeout);
				this.running=true;
				this.startedat=Date.now();				this.targettime=20+parseInt(this.startedat+ parseInt(this.currenttime));

				this.timeout=setInterval(this.update,200);
			},

			update:function() {
				this.currenttime=this.targettime-Date.now();		
				if(this.currenttime<=0) {
					this.timesup();
				}
			},
			
			timesup:function() {
				this.stop();
				tools.timer.timesup();
			},
			
			settime:function(newtime){
				this.starttime=newtime;
			},
			
			reset:function() {
				this.stop();
				this.currenttime=(activitydata[this.id].time) ? activitydata[this.id].time*1000 : 60 * 1000;
			}
		};
		
		timer.update=timer.update.bind(timer);
		
		return timer;
	},
	
	settimer:function(id) {
		if(!app.timers[id]) {
			app.timers[id]=this.newtimekeeper(id);
		}
		return app.timers[id];
	},
	
	init:function() {
		this.togglestart=this.togglestart.bind(this);
		this.reset=this.reset.bind(this);
		this.update=this.update.bind(this);
	},
	teardown:function() {
	
	}
};
tools.timer.init();

/* TIMED COUNTER */
tools.timedcounter={

	add:function() {
		if(tools.timer.usetimer.running) {
			tools.counter.add();
		}
	},
	subtract:function() {
		tools.counter.subtract();	
	},
	togglestart:function() {
		tools.timer.togglestart();
		changeclass(panel.tool.ui.plus,'disabled',tools.timer.usetimer.running);
	},
	reset:function() {
		tools.timer.reset();
		tools.counter.reset();
		changeclass(panel.tool.ui.plus,'disabled',tools.timer.usetimer.running);
	},

	activate:function() {
		// set up a counter and a timer
		tools.timer.activate();
		tools.counter.activate();
		// disable the plus button
		changeclass(panel.tool.ui.plus,'disabled');
	},

	results:function(id) {
		return tools.counter.results(id);
	}
,

	init:function(){
	
	}
};
tools.timedcounter.init();

/* STOPWATCH */
// similar to timer
tools.stopwatch={
	progress:0,
//	startedat:null,
//	starttime:0,
//	currenttime:0,
	timeout:null,
//	running:false,
	startbutton:null,
	showtime:null,

	togglestart:function() {
		if(this.usetimer.running) {
			this.stop();
		} else {
			this.start();
		}
	},
	start:function() {
		this.usetimer.start();
//		this.running=true;	
		clearInterval(this.timeout);
		this.timeout=setInterval(this.update,100);
		this.startbutton.innerHTML="Stop";
//		this.startedat=Date.now()-this.currenttime;
		this.progress=0;
		cards.checkcompletion(this.progress);
	},
	
	stop:function() {
		this.usetimer.stop();
//		this.running=false;
		clearInterval(this.timeout);
		this.startbutton.innerHTML="Start";
		this.progress=1;
		cards.checkcompletion(this.progress);
	},
	reset:function() {
//		this.currenttime=0;
		this.usetimer.reset();
		this.display();
	},
	update:function() {
		// every .5 seconds update
//		this.currenttime+=100;
//		this.currenttime=Date.now() - this.startedat;
		this.display();
	},
	display:function(){
		this.showtime.innerHTML=this.convert(this.usetimer.currenttime);
	},
	convert:function(ms) {
		// converts seconds to hours:minutes:seconds with zero padding on minutes (if there are any hours) and seconds. Only do hours if it's more than two hours.
		var num=parseInt(ms/1000);
		var minutes=parseInt(num/60);
		var seconds=parseInt(num%60);
		var anyhours="";
		if(minutes > 120) {
			var hours=parseInt(minutes/60);
			minutes=zeropad(minutes-(hours*60));
			anyhours=hours+":";
		}
		var hundredths=parseInt((ms%1000)/100);
		return anyhours + minutes + ":" + zeropad(seconds) + "." + zeropad(hundredths,1);
	},
	calibrate:function() {
		// every so often, calibrate against the start time in case of drift
		
	},
	
	
	newtimekeeper:function(id) {
		
	//	var time=(activitydata[app.mission].time) ? activitydata[app.mission].time*1000 : 60 * 1000;
		
		var stopwatch={
			startedat:null,
			running:false,
			currenttime:0,

			stop:function() {
				this.running=false;
				clearInterval(this.timeout);
			},

			start:function() {
				this.running=true;
				this.startedat=Date.now();				//this.targettime=20+parseInt(this.startedat+ parseInt(this.currenttime));
				clearInterval(this.timeout);
				this.timeout=setInterval(this.update,100);
			},

			update:function() {
				this.currenttime=Date.now() - this.startedat;
			},
			
			reset:function() {
				this.stop();
			}
		};
		
		stopwatch.update=stopwatch.update.bind(stopwatch);
		
		return stopwatch;
	},
	
	settimer:function(id) {
		if(!app.timers[id]) {
			app.timers[id]=this.newtimekeeper(id);
		}
		return app.timers[id];
	},
	
	activate:function() {
		this.progress=0;
		this.startbutton=panel.tool.ui.tstart;
		this.showtime=panel.tool.ui.sdisplay;
		

		this.usetimer=this.settimer(app.mission);
		
	},
	
	results:function(id) {
		var usetimer=this.settimer(id);
		return "Your time was " + usetimer.currenttime;
	}
,
	
	init:function() {
		this.togglestart=this.togglestart.bind(this);
		this.reset=this.reset.bind(this);
		this.update=this.update.bind(this);
	}
};
tools.stopwatch.init();

/* SCAVENGER HUNT */
tools.scavenger={
	progress:0,
	enlarged:false,
	checked:[],
	// make the list
	
	// look up list from current activity
	
	launch:function() {
		this.checked={};
		var arr=activitydata[app.mission].list;
		for(var a in arr) {
			this.checked[a]=false;
		}
	},
	
	lookuplist:function() {
	//	this.checked={};
	
		var arr=activitydata[app.mission].list;
		var html=this.makelist(arr);
		return html;
	},
	
		
	statushtml:function() {
	var html='<div id="huntstatus">';
	var yesorno="";
	var num=0;
		for(var a in this.checked) {
			num++;
/*			if(this.checked[a]) {
				yesorno="*";
			} else {
				yesorno="&nbsp;";
			}
*/
			html+="<div class=\"statusbox\" id=\"hunt_"+num+"\"></div>";
		}
		html+="</div>";
		return html;
	},
	
	
	makelist:function(array) {
		var html="<ul id=\"hunt\">";
		var useimage=activitydata[app.mission].type=='image';;
		var im='';
		for(var a in array) {
			if(useimage) {
				im='<img class="figure" src="img/act/'+app.mission+'/'+array[a]+'.png" />';
			}
			html+="<li id=\"s"+a+"\"><button id=\"b_"+a+"\"><img src=\"img/checkbox_blank.svg\" class=\"checkbox\" />"+im+"<span class=\"label\">" + array[a] + "</span></button></li>";
		}
		html+="</ul>";
		return html;
	},
	
	showlist:function(ev) {
		
		if(tools.enlarged) {
			this.close();
		} else {
		
//		ev.target.removeEventListener(app.taptype,scavenger.showlist);
//		ev.target.addEventListener(app.taptype,scavenger.hidelist);

			var o=document.getElementById('openlist');
			o.innerHTML='Close <img src="img/chevron_down.svg" class="icon" />';
			tools.largetool();
		}
	},
	
	hidelist:function(ev) {
	// switch to show list
//		ev.target.removeEventListener(app.taptype,scavenger.hidelist);
//		ev.target.addEventListener(app.taptype,scavenger.showlist);
		tools.smalltool();
	},
	
	close:function() {
		var o=document.getElementById('openlist');
		o.innerHTML='Open <img src="img/chevron_up.svg" class="icon" />';
		tools.smalltool();
	},
	
	togglethis:function(ev) {
		// if this one is checked, then uncheck it?
		var which=ev.currentTarget;
		var ind=which.id.replace("b_","");
		this.setthis(which,ind,!this.checked[ind]);
	},
	
	setthis:function(which,ind,checked) {
		if(checked) {
			this.checked[ind]=true;
			changeclass(which,'filled');
			which.childNodes[0].src='img/checkbox_checked.svg';
		} else {
			this.checked[ind]=false;
			changeclass(which,'filled',true);
			/*which.childNodes[0].onload=function(){
				//alert('width ' + which.childNodes[0].width)
				};
				*/
				which.childNodes[0].src='img/checkbox_blank.svg';

		}
		this.updatestatus();
	},
	
	updatestatus:function() {
		var num=0,count,cl=0;
		var savecheck=[];
		for(var a in this.checked) {
			savecheck[a]=this.checked[a];
			if(this.checked[a]) {
				num++;
				count=document.getElementById("hunt_"+num);
				changeclass(count,'filled');
			}
			cl++;
		}
		
		
		this.progress=num/cl;
		cards.checkcompletion(this.progress);
		
		num++;
		for(var b=num;b<=cl;b++) {
			count=document.getElementById("hunt_"+b);
			changeclass(count,'filled',true);
		}
		user.savetoopenmission(app.mission,'found',savecheck);
		
	},

	
	teardown:function() {

	},
	init:function() {
		this.showlist=this.showlist.bind(this);
		this.togglethis=this.togglethis.bind(this);
		this.lookuplist=this.lookuplist.bind(this);
		this.statushtml=this.statushtml.bind(this);
	},
	activate:function() {
		// wire up the tool after the panel is in place
		
		var usegrid=activitydata[app.mission].type=='image';
		var d=document.getElementById('huntsection');
		changeclass(d,'grid',!usegrid);
		
//		this.checked=[];
		var getchecked=user.loadfromopenmission(app.mission,'found');
		if(getchecked) {
			this.progress=getchecked.length/this.checked.length;
		} else {
			this.progress=0;
		}

		for(var a in this.checked) {
			var b=document.getElementById("b_"+a);
			if(getchecked) {
				this.checked[a]=getchecked[a];
			} else {
				this.checked[a]=false;
			}
			if(b) {
				//b.removeEventListener(app.taptype,this.togglethis);
				//b.addEventListener(app.taptype,this.togglethis);
				taketaps(b,'click',this.togglethis);
				this.setthis(b,a,this.checked[a]);
			}
		}
	},
	
	results:function(id) {
		;
		var found=user.loadfromopenmission(id,'found');
		var total=0;
		for(var f in found) {
			if(found[f]) total++;
		}
		return "You found " + total + " out of " + activitydata[id].list.length;
	}
};

tools.scavenger.init();


tools.converter={
	progress:1
};

tools.none={
	progress:1
};

/*

var cameraSuccess=function(image) {

	thumbnail.src=image;
	
};

var cameraError=function() {
	window.alert("error");
};

var cameraOptions=null;


var showcamera=function() {
//	showcamera2();
	navigator.camera.getPicture(cameraSuccess, cameraError, cameraOptions);
};

var imageSuccess=function(media) {
	navigator.notification.alert('Success, allegedly');
	thumbnail.src="data:image/jpeg;base64,"+media;
	window.alert("success");
};

var imageError=function(error) {
	navigator.notification.alert('Error code: ' + error.code, null, 'Capture Error');
	window.alert("error");
};

var showcamera2=function() {
	showvideo();
//	navigator.device.capture.captureImage(imageSuccess,imageError,{limit:3});
};
*/


/* WEATHER FUNCTIONS */

var weather={
	report:{},
	lastcheck:0,
	checkinterval:60*60*1000, // check again in an hour
	getweather:function(lat,lng) {
		var url='http://graphical.weather.gov/xml/sample_products/browser_interface/ndfdXMLclient.php?whichClient=GmlLatLonList&gmlListLatLon='+lat+','+lng+'&featureType=Forecast_Gml2Point&propertyName=maxt,wx,icons';
		
		// need to add http://graphical.weather.gov/ to content= in default-src
		
		var apikey="b66049bf1fcbc8d3ef452c98780978c1";
		
		url='https://api.darksky.net/forecast/'+apikey+'/'+lat+','+lng;
		// need to add https://api.forecast.io to content= in default-src. Now is darksky.net instead of forecast.io
		var me=this;
		var reqweather=new XMLHttpRequest();
		reqweather.open("GET",url,true);
		reqweather.onreadystatechange=function() {
			if(reqweather.readyState === XMLHttpRequest.DONE && reqweather.status === 200) {
           // alert(reqweather.responseText);
           	me.gotweather(reqweather.responseText);
       	 }
		}
		
		reqweather.send();
		
	},
	gotweather:function(json) {
		this.lastcheck=Date.now();
		this.report=JSON.parse(json);
		var wi=document.getElementById('weather'); // fill weather report if it's showing
		if(wi) {
			wi.innerHTML=this.showweather();
		}
	},
	icons:{
	"clear-day":"wi-forecast-io-clear-day",
	"clear-night":"wi-forecast-io-clear-night",
	"rain":"wi-forecast-io-rain",
	"snow":"wi-forecast-io-snow",
"sleet":"wi-forecast-io-sleet",
"strong-wind":"wi-forecast-io-wind",
"fog":"wi-forecast-io-fog",
"cloudy":"wi-forecast-io-cloudy",
"cloudy-day":"wi-forecast-io-partly-cloudy-day",
"cloudy-night":"wi-forecast-io-partly-cloudy-night",
"hail":"wi-forecast-io-hail",
"thunderstorm":"wi-forecast-io-thunderstorm",
"tornado":"wi-forecast-io-tornado"
	},
	
	geticon:function(reporticon) {
		return "<i class=\"wi "+this.icons[reporticon]+"\"></i>"
	},
	
	
	showweather:function() {
		if(this.report.currently) {
		
			// if haven't checked in a while, check again.
			if(Date.now()-this.lastcheck > this.checkinterval) {			this.getweather(geolocation.position.coords.latitude,geolocation.position.coords.longitude);
			}
		
			var icon=this.geticon(this.report.currently.icon);
			return "Weather: "  + icon+ " " + parseInt(this.report.currently.temperature) + "&deg;F " + this.report.currently.summary;
			
		}
		
		return "";
	}
};

var geolocation={
	position:{coords:{latitude:42.355,longitude:-71.149}},
	getposition:function() {
		navigator.geolocation.getCurrentPosition(this.gotposition,this.geoerror);
	},
	gotposition:function(position) {
		this.position=position;
		weather.getweather(position.coords.latitude,position.coords.longitude);
	},
	geoerror:function() {
	},
	init:function() {
		this.gotposition=this.gotposition.bind(this);
		this.geoerror=this.geoerror.bind(this);
	}
};


/*
var reqweather;

var getweather=function(lat,lng) {
	// lat=37 lng=-122
		var url='http://graphical.weather.gov/xml/sample_products/browser_interface/ndfdXMLclient.php?whichClient=GmlLatLonList&gmlListLatLon='+lat+','+lng+'&featureType=Forecast_Gml2Point&propertyName=maxt,wx,icons';
		var g=document.getElementById('copy');
		
		//url="http://pbskids.org/";
		
		//url="https://api.forecast.io/forecast/b66049bf1fcbc8d3ef452c98780978c1/37.8267,-122.423";
		
		g.innerHTML=url;
		
		
		
		reqweather=new XMLHttpRequest();
		reqweather.open("GET",url,true);
		reqweather.onreadystatechange=function() {
			if(reqweather.readyState === XMLHttpRequest.DONE && reqweather.status === 200) {
            alert(reqweather.responseText);
        }
		}
		
		reqweather.send();
		
		
		
		
		//window.location=url;
};

//getweather(37,-122);

var gotposition=function(position) {
 		var res='Latitude: '          + position.coords.latitude          + '\n' +
              'Longitude: '         + position.coords.longitude         + '\n' +
              'Altitude: '          + position.coords.altitude          + '\n' +
              'Accuracy: '          + position.coords.accuracy          + '\n' +
              'Altitude Accuracy: ' + position.coords.altitudeAccuracy  + '\n' +
              'Heading: '           + position.coords.heading           + '\n' +
              'Speed: '             + position.coords.speed             + '\n' +
              'Timestamp: '         + position.timestamp                + '\n';
              
          var g=document.getElementById('weather');
          g.innerHTML=res;
          
          getweather(position.coords.latitude,position.coords.longitude);
//          alert('success');
    };
    
 var geoerror=function(er){
    alert('code: '    + er.code    + '\n' + 'message: ' + er.message + '\n');
}

var checkgeo=function() {
	navigator.geolocation.getCurrentPosition(gotposition,geoerror);
};

*/

/* VIDEO FUNCTIONS */
/*
var errBack=function() {
	alert('Video capture error');
};

var showvideo=function() {
	navigator.notification.alert("oaxaca");
	var video = document.getElementById("video");
	if(navigator.getUserMedia) { // Standard
		navigator.getUserMedia(videoObj, function(stream) {
			video.src = stream;
			video.play();
		}, errBack);
	} else if(navigator.webkitGetUserMedia) { // WebKit-prefixed
		navigator.webkitGetUserMedia(videoObj, function(stream){
			video.src = window.webkitURL.createObjectURL(stream);
			video.play();
		}, errBack);
	} else {
		
	//	alert('getusermedia not supported');
	}
};


*/


app.initialize();



/* TEMPLATES */


var templates={
	reg:/%%([^%]+)%%/igm,
	parse:function(str) {
	// should do some substitutions - replace any %%key%% with result of the function in templates.subs[key]
		if(templates.subs && templates.reg.test(str)) {
			// has at least one substitution
			str=str.replace(templates.reg,function(m){
				m=m.replace(/%%/g,'');
				var f=templates.subs[m];
				return f(m);
				});
		}
	
		return str;
	},
	
	setsubs:function(config) {
		for(var k in config) {
			templates.subs[k]=config[k];
		}
	},
	
	blank:{html:''},
	
	singlecard:{
		html:'<div id=\"allcards\" class=\"cardset transit\">%%id%%</div>',
	
		subs:{
			id:cards.makecard
		}
	},
	
// card states
	completed:{
	/*	html:'<div id="allcards" class="complete"><div class="actcard big" id="%%id%%"><div class="f1_1 ctr">%%title%% Completed!</div>\
		<div class="ctr"><img src="img/smallplum.png" /><br /><form><textarea id="sumup">What did you think?</textarea></form><br />How would you rate this mission?</div><div class="f3_5 ctr"><div class="f1_3 col"><button id="good" class="circle"><img src="img/smile.svg"></button></div><div class="f1_3 col"><button id="meh" class="circle"><img src="img/meh.svg"></button></div><div class="f1_3 col"><button id="bad" class="circle"><img src="img/frown.svg"></button></div></div></div></div>',*/
		
		html:'<div id="allcards" class="complete"><div id="%%id%%"><div class="ctr"><img src="img/complete_great.png" alt="Great Job!" width="290" height="61" style="margin-top:3px;><div class="f1_1 ctr">%%title%% Completed!<br />%%results%%</div><img src="img/complete_plum2.png" alt="" width="210" height="195"><div id="bonus" class="ctr f1_2"></div><div id="newpoints" class="ctr f1_2 pointsbox"> points</div></div>',
		
		buttons:{
		},
		subs:{
			id:cards.currentid,
			title:app.missionproperty,
			results:cards.currentresults
		}
	},

// nav buttons
	carousel:{
		html:'<div class="f1_4 col vctr"><button id="arrowleft" class="squircle bg-green ctr"><img src="img/chevron_left.svg"  width="30" height="30" /></button></div>\n<div class="f1_2 col vctr"><div class="f1_1 fullctr" id="carddots"></div></div>\
		<div class="f1_4 col vctr"><div class="f1_1 rj"><button id="arrowright" class="squircle bg-green ctr"><img src="img/chevron_right.svg" width="30" height="30" /></button></div></div>',
		
		buttons:{
			'arrowright':{'tap':cards.nextcard},
			'arrowleft':{'tap':cards.prevcard}
		}
	},
	
	activity:{
		html:'<div class="f1_2 col vctr"><button id="close" class="bg-orange f3_4">Done For Now</button></div>\
		<div class="f1_2 col vctr"><div class="f1_1 rj"><button id="complete" class="bg-orange f3_4">All Done!<img src="img/checkmark.svg" class="icon completecheck" /></button></div></div>',
		
		buttons:{
			'close':{'tap':nav.back},
			'complete':{'tap':cards.done}
			}
	},
	
	back: {
		html:'<div class="f1_2 col"><button id="back" class="bg-green f2_3"><img src="img/arrowleft.svg" class="icon" /> Back</button></div>\
		<div class="f1_2 col"></div>',
		buttons:{
			'back':{'tap':cards.goback}
		}
		
	},
	
	okay: {
			html:'<div class="f2_3 col">&nbsp;</div>\
		<div class="f1_3 col fullctr"><div class="f1_1 rj"><button id="okay" class="f5_6 disabled">Okay <img src="img/arrowright.svg" class="icon" /></button></div></div>',
		buttons:{
			'okay':{'tap':nav.home}
		}
	},
	
// homepage
	index:{
		html:'<div id="index"><div id="indextop"><img id="parentinfo" src="img/iparents.svg" height="22" width="81" alt="Info for parents" /><div class="ctr"><img src="img/home_title.png" alt="" width="286" height="76" class="ctr"></div></div>\
		<div id="dashboard">[ DASHBOARD ]</div>\
		<div id="indexbuttons" class="vctr"><div class="f1_1"><button class="ctr bigbutton" id="showcards">Today\'s Missions<div id="today"></div></button><button class="ctr bigbutton bg-green" id="inprogress"> Missions in Progress</button><button class="ctr bg-green bigbutton" id="allmissions">All Missions</button></div></div></div>',
		
		buttons:{
			'parentinfo':{'tap':nav.parents}
		}
	},

// list 
	list:{
		html:'<div id="list" class="scroll">%%list%%</div>',
	subs:{
		list:listview.activitylist
	}
	},


// tools
	camera:{
		html:'\
		<div id="toprow"><div class="f3_4 col fullctr"><div class="f1_5 col le"><button id="p1" class="nobg photothumb"><img id="i1" alt="" class="thumbnail" /></button></div> <div class="f1_5 col fullctr"><button id="p2" class="nobg photothumb"><img id="i2" alt="" class="thumbnail" /></button></div><div class="f1_5 col fullctr"><button id="p3" class="nobg photothumb"><img id="i3" alt="" class="thumbnail" /></button></div><div class="f1_5 col fullctr"><button id="p4" class="nobg photothumb"><img id="i4" alt="" class="thumbnail" /></button></div><div class="f1_5 col fullctr"><button id="p5" class="nobg photothumb"><img id="i5" alt="" class="thumbnail" /></button></div></div>\
		<div class="f1_4 col fullctr"><button id="camera" class="bg-orange f3_4"><img src="img/camera.svg" /></button></div></div>\
		<div class="f1_1 col ctr"><img id="ilarge" /></div>',
		
		buttons:{
			'camera':{'tap':tools.camera.showcamera},
			'p1':{'tap':tools.camera.enlarge},
			'i1':{},
			'p2':{'tap':tools.camera.enlarge},
			'i2':{},
			'p3':{'tap':tools.camera.enlarge},
			'i3':{},
			'p4':{'tap':tools.camera.enlarge},
			'i4':{},
			'p5':{'tap':tools.camera.enlarge},
			'i5':{},
			
			'ilarge':{}
		}
	},
	
	counter:{
		html:'<div id="toprow"><div class="f1_5 col pad"></div>\
		<div class="f3_5 col fullctr"><!--button id="minus" class="bg-green colr squircle "><img src="img/minus.svg" alt="minus" width="25" height="25" /></button--><button id="plus" class="bg-orange squircle vcenter"><img src="img/plus.svg" alt="add" width="25" height="25" /></button><span id="cdisplay" class="large lining tooldisplay f2_5">0</span></div>\
		<div class="f1_5 col pad"></div></div>',

		buttons:{
//			'minus':{'tap':tools.counter.subtract},
			'plus':{'tap':tools.counter.add},
			'cdisplay':{}
		}
	},
	
	timedcounter:{
		html:'<div id="toprow"><div class="f1_3 col vctr"><!--button id="minus" class="bg-green squircle"><img src="img/minus.svg" alt="minus"  width="25" height="25"/></button--><button id="plus" class="bg-orange squircle le"><img src="img/plus.svg" alt="add" width="25" height="25" /></button><span id="cdisplay" class="large lining tooldisplay f5_12">0</span></div>\
		<div class="f1_12 col pad"></div>\
		<div class="f7_12 col vctr"><span id="tdisplay" class="large lining tooldisplay f1_2 colr">0</span> <button id="tstart" class="bg-green colr f5_12">Start</button> <button id="treset" class="bg-green squircle re"><img src="img/reset.svg" alt="reset" width="25" height="25" /></button></div></div>',
		buttons:{
			'treset':{'tap':tools.timedcounter.reset},
			'tstart':{'tap':tools.timedcounter.togglestart},
//			'minus':{'tap':tools.timedcounter.subtract},
			'plus':{'tap':tools.timedcounter.add},
			'tdisplay':{},
			'cdisplay':{}
		}
	
	},
	
	timer:{
		html:'<div id="toprow"><div class="f1_5 col ctr">&nbsp;</div><div class="f2_5 col ctr"><span id="tdisplay" class="large lining">0</span></div>\
		<div class="f1_5 col"><button id="tstart" class="bg-green f5_6 col">Start</button></div><div class="f1_5 col"><button id="treset" class="bg-green f5_6 colr short"><img src="img/reset.svg" alt="reset" width="25" height="25" /></button></div></div>',
		buttons:{
			'treset':{'tap':tools.timer.reset},
			'tstart':{'tap':tools.timer.togglestart},
			'tdisplay':{}
		}
	},
	
	stopwatch:{
		html:'<div id="toprow"><div class="f1_5 col"><button id="treset" class="bg-green f4_5 colr"><img src="img/reset.svg" alt="reset" width="25" height="25" /></button></div>\
		<div class="f3_5 col ctr"><span id="sdisplay" class="large lining">0</span></div>\
		<div class="f1_5 col"><button id="tstart" class="bg-green f4_5 col">Start</button><div class="f2_3 col"></div></div></div>',
		buttons:{
			'treset':{'tap':tools.stopwatch.reset},
			'tstart':{'tap':tools.stopwatch.togglestart},
			'sdisplay':{}
		}
	},
	
	scavenger:{
		html:'<div id="toprow"><div class="f2_3 col vctr">%%status%%</div><div class="f1_3 col vctr"><div class="f1_1 rj"><button id="openlist" class="f4_5 bg-orange re">Open <img src="img/chevron_up.svg" class="icon" /></button></div></div></div>\
		<div class="f1_1 col" id="huntsection">%%list%%</div>',
		buttons:{
			'openlist':{'tap':tools.scavenger.showlist}
		},
		subs:{
			'list':tools.scavenger.lookuplist,
			'status':tools.scavenger.statushtml
		}
	},
	
	stats:{
		html:'<div id="list" class="scroll"></div>'
	},
	
	parents:{
		html:'<div class="scroll"><div id="parentblurb"><h1>Dear Parents!</h1>\
\
<p>Thank you so much for taking the time to help us test our new app! We hope you\'ll use it many times with your kids and will share your feedback about it with the folks that loaned you this iPod.</p>\
\
<p>Every day we\'ll offer you five missions to do outside with your kids, to get you all thinking and talking about science and the world around you. You can skip missions or choose new ones from the "All Missions" menu.</p>\
\
<p>We\'re using the iPod to give you activities to do &mdash; Missions &mdash; and with most of them you also will use the device to help make this fun. You\'ll find:</p>\
\
<h2>Camera Missions</h2>\
<img src="img/parents/parents1.png" width="270" height="144" alt="" />\
<p>Here you\'ll be taking five pictures, sometimes over five different days. They\'ll save into the app as well as to the camera roll if you\'d like to look at them. <i>(Please don\'t delete the camera roll &mdash; we really need to see the photos you\'re taking!!)</i></p>\
\
<h2>Counting and Timer Missions</h2>\
<img src="img/parents/parents2.png" width="180" height="144" alt="" />\
<p>Some missions have you and your family looking for different things in a fixed time &mdash; the app may ask you how many pigeons can you count in 5 minutes.</p>\
\
<h2>Scavenger Hunt</h2>\
<img src="img/parents/parents3.png" width="270" height="144" alt="" />\
<p>We have a few missions that give you a scavenger hunt checklist of things to find. Just check them off until you\'re All Done.</p>\
\
<h2>Open Missions</h2>\
<img src="img/parents/parents4.png" width="86" height="144" alt="" />\
<p>Some of the missions are activity ideas for fun things to do on a walk, and to talk about &mdash; like what it would be like if you were a bird or a fly. Just click All Done (when you are) to get your points!</p>\
\
<p>Along the way you\'ll be able to go back to Open Missions (ones you\'ve started but not finished) and you\'ll get points for completing missions (by clicking the button to let the app know you\'re All Done.)</p>\
\
<p>Try to use this at least three times per week for the time you have the device and please let the folks know if you\'re having any problems.</p>\
\
<p>Thank you!<br />\
<i>Team Plum</i></p><div class="teeny">v 0 . 1 . 0</div></div></div>'

	}
};



/* function to resize the window after loading; used for testing in web browser */

function websize() {
	var chrome=46; //chrome offset for Safari=61. Small window chrome=46
	var wchrome=0;
	//var w=320,h=533; // 320x480=4:3, 320x568=HD, 853x640=iPad, 320x533=Android
	
	var getqs=function(key) {
		var qst=window.location.search.substring(1).split('&');
		var re=new RegExp(key);
		for(var z in qst) {
			if(re.test(qst[z])) {	
				var sp=qst[z].split('=');
				return sp[1];
			}
		}
		
		return false;
	}
	
	var w=parseInt(getqs('w'));
	var h=parseInt(getqs('h'));
	if(!w) w=320;
	if(!h) h=533;
	
	
	window.resizeTo(w+wchrome,h+chrome);

/*
	var fr=document.getElementById('frame');


	fr.style.width=window.w + 'px';
	fr.style.height=window.h + 'px';
*/

	app.getsize(); // resize app
}


// data ready for 
if(!window.cordova) {
//	user.dataready();
	websize();
	
	//weather.getweather(geolocation.position.coords.latitude,geolocation.position.coords.longitude);
//	window.alert("no cordova");
}

/*
var startclick=function(ev) {
	
};
var endclick=function(ev) {
	document.dispatchEvent(clickevent);
};
*/

var lasttarget,lastco,newco,scrolling,stopscroll;

var clickdown=function(ev) {
	if(scrolling) return;

	lasttarget=ev.currentTarget;
	lastco=newco=app.getcoords(ev);

};

var clickmove=function(ev) {
	if(lasttarget==ev.currentTarget) {
		newco=app.getcoords(ev);

	}
}

var noscroll=function() {
	scrolling=false;
}

var inscroll=function(e) {
		scrolling=true;
		clearTimeout(stopscroll);
    	stopscroll=setTimeout(noscroll,200);
}


var clickup=function(ev) {

	if(scrolling) return;
	if(lasttarget==ev.currentTarget) {
		var dist=(newco.x-lastco.x)*(newco.x-lastco.x) + (newco.y-lastco.y)*(newco.y-lastco.y);
		var range=ev.currentTarget.clickrange?ev.currentTarget.clickrange:250;
		if(dist < range) {
			ev.currentTarget.dispatchEvent(clickevent);
		}
	}
	lasttarget=null;
};

//document.addEventListener(app.tap.down,startclick);
//document.addEventListener(app.tap.up,endclick);
