// search stuff. Create an index based on the activities, and then return results sorted by match

var search;

(function() {

	var st={};
	
	st.index={}; // 
	st.wordlist=[];
	st.common={
	'a':1,
	'an':1,
	'in':1,
	'the':1,
	'to':1,
	'of':1,
	'what':1
	};
	
	st.autocomplete=function(str) {
		// return an autocomplete list based on what will ACTUALLY match
		var list=[];
		//console.log("autocomplete " + str + " " + this.wordlist.length);
		str=str.toLowerCase(); // mobile tends to title case things
		for(var w in this.wordlist) {
			//console.log("look at " + this.wordlist[w]);
			if(this.wordlist[w].indexOf(str)===0) { // startsWith() is not well supported on mobile
				//console.log("match " + w);
				list.push(this.wordlist[w]);
			}
		}
		return list;
	};
	
	st.tosscommon=function(word) {
		if(this.common[word]) return true;
		return false;
	};
	
	st.wordsfromstring=function(str) {
		// make lowercase and replace punctuation
		str=str.replace(/[.!?,;()"]/g,"");
		str=str.toLowerCase();
		var sentence=str.split(' ');
		return sentence;
	};
	
	st.makeindex=function(activities) {
		// record the number of times each word appears?
		for(var a in activities) {
			var id=a;
			var act=activities[a];
			var sentence=this.wordsfromstring(act.title);
			sentence=sentence.concat(this.wordsfromstring(act.desc));
			sentence=sentence.concat(this.wordsfromstring(act.full));
			sentence=sentence.concat(this.wordsfromstring(act.tool));
			for(var pos in sentence) {
				var word=sentence[pos];
				if(this.tosscommon(word)) continue;
				//console.log(word + "," + pos);
				if(!this.index[word]) {
					this.index[word]={};
				}
				if(!this.index[word][id]) {
					this.index[word][id]=[];
				}
				this.index[word][id].push(pos);	
			}
		}
		
		for(var w in this.index) {
			this.wordlist.push(w);
		}
		
	};
	
	st.search=function(str) {
		//console.log("search " + str);
		// break up the string into pieces, get matches, rank them, return ordered list of IDs
		var words=this.wordsfromstring(str);
		var list={};
		var order=[];
		for(var w in words) {
			var word=words[w];
			//console.log("look for " + word);
			if(this.index[word]) {
			//	console.log("match " + word);
				for(var id in this.index[word]) {
					if(!list[id]) list[id]=0;
					list[id]=list[id]+this.index[word][id].length;
				}
			}
			
		}
		for(var l in list) {
			order.push({'id':l,'m':list[l]});
		}
		order.sort(function(a,b) {
			if(a.m > b.m) return -1
			return 1;
		});
		return order;
	};

 search=st;
}());